<?php
/**
 *CampaignsController
 * @author Ohjelmistotuotantoprojektiryhm myva, Helsingin yliopisto, Tietojenksittelytieteenlaitos
 * @version
 * @package myva
 * @subpackage Controllers
 */
class CampaignsController extends AppController {

  var $name = 'Campaigns';
  var $uses = array('Campaign', 'TargetClient', 'SalesArgument', 'Classification', 'User', 'CampaignsUser', 'Event', 'ClassificationsTargetClients', 'CampaignsUser', 'MessageLink');
  var $helpers = array('html', 'javascript', 'time', 'time_fi');

  /**
   * Luokan alustusfunktio. Asettaa metodit, joiden yhteydess nytetn valikot, tai jotka vaativat yllpitjn kyttoikeudet.
   */
  function __construct (){
    parent::__construct();
    //    $this->need_not_login = array();
    $this->need_admin = array('campaignManagement', 'campaignReport');
    $this->need_menus = array('campaignManagement', 'userCampaignReport', 'campaignReport', 'index');
  }

  /**
   * Tuottaa aloitussivun
   * @param int $campaign_id Kampanjan tunnistetieto
   */
  function index($campaign_id = null){
    if ($campaign_id == null){
      $this->set('campaign_selected', false);
    } else {
      $this->set('campaign_selected', true);
      //Tarkistetaan onko meill kampanja, johon voi tehd soittoja
      // Otetaan kyttj
      $user = $this->Session->read('user');
      //Kyttjrajaus
      $search_array = array("CampaignsUser.user_id" => $user['id'],
      "CampaignsUser.campaign_id" => $campaign_id);
      //Aikarajaus
      $search_array[0] = "Campaign.start_time <= date(now()) and (Campaign.end_time >= date(now()) or Campaign.end_time is null)";
      $campaign = $this->CampaignsUser->find($search_array);
      if (empty($campaign)){
        $this->set('campaign_selected', false);
      } else {
        //Lasketaan paljonko soittoja tehty tnn
        $calls_today = $this->CampaignsUser->getCallsDoneToday($campaign_id, $user['id']);
        // Jljell
        $calls_left = $this->CampaignsUser->getCallsPerDay($campaign_id, $user['id']) - $this->CampaignsUser->getCallsDoneToday($campaign_id, $user['id']);
        // Jos jljell negatiivinen, niin 0
        if ($calls_left < 0){
          $calls_left = 0;
        }
        //Muuttujarajapinta nkymiin
        $this->set('calls_today', $calls_today);
        $this->set('calls_left', $calls_left);
        $this->set('campaign_id', $campaign_id);
        //Tyylit sisn
        $this->set('styles', array('campaigns/index'));
      }




    }
     
  }


  /**
   *  Kampanjaan liittyvn shkpostiviestin noutaminen
   *
   *  Hakee kannasta tiettyy kampanjaan liittyvn viestin,
   *  saa parametrina url:ssa kampanjan tunnistetiedon
   *
   *  Asettaa lopuksi shkpostiviestin tiedot email_message muuttujaan
   *  nkym varten
   *
   *  @param int $campaign_id Kampanjan tunnistetieto
   */

  function showMessage($campaign_id){
     
    if (!empty($campaign_id)){
      $session_info = $this->Session->read('user');
      $result = $this->Campaign->showMessage($campaign_id, $session_info['id']);
      if (!empty($result)){
        $this->set('email_message', $result);
        $this->render('showMessage','ajax');
      } else {
        //TODO miten virhetilanne pitisi hoitaa? (ohjaa tll hetkell /user/index)
        $this->flash("Kampanjan ID ei lytynyt kannasta", '/users/index');
      }
    } else {
      //TODO miten virhetilanne pitis hoitaa? (ohjaa tll hetkell /user/index)
      $this->flash("Kampanjan ID puuttuu", '/users/index');
    }
  }

  /**
   * Tarkistaa kohdeyrityksi listtess tuleeko lhiosumia
   * annetuilla tiedoilla
   *
   * @param int $campaign_id Kampanjan tunnistetieto
   * @param postarray $data Hakuehdot
   *   <ul>
   *     <li>['form']['add_source'] string Lhde, josta uudet kohdeasiakkaat listn. Sallitut arvot: file=tiedostosta, form=lomakkeesta.</li>
   *     <li>['form']['data']['TargetClient']['name'] string Kohdeasiakkaan nimi.</li>
   *     <li>['form']['data']['TargetClient']['y_id'] string Kohdeasiakkaan y-tunnus.</li>
   *     <li>['csv_file_name'] Tiedoston nimi, joka sislt kohdeasiakkatai.</li>
   *     <li>['form']['for_user'] boolean True jos kohdeyritykset liitetn kirjautuneelle kyttjlle, false mikli menevt pooliin (ei kenellekkn).</li>
   *     <li>['form']['after_save_path'] string Toimitetaan nkymlle.</li>
   *   </ul>
   */

  function checkContacts($campaign_id) {

    $data = $this->params;
    $rowcounter = 0;

    $for_user = $data['form']['for_user'];
    $after_save_path = $data['form']['after_save_path'];
    //Jos lhde on form, suoritetaan if
    if (strcmp($data['form']['add_source'], "form") == 0) {
      $stripped = $this->stripName($data['form']['data']['TargetClient']['name']);
      $y_id = $data['form']['data']['TargetClient']['y_id'];
      if(!preg_match(VALID_YID_OR_EMPTY, $y_id)){
        $this->flash('Y-tunnus virheellinen', '/campaignsUsers/showCampaignTargets/' . $campaign_id . '/unfinished');
        exit();
      }

      //Tytetn arrayn muutamat solut tarvittavilla tiedoilla
      $formdata['TargetClient']['name'] = $data['form']['data']['TargetClient']['name'];
      $formdata['TargetClient']['y_id'] = $data['form']['data']['TargetClient']['y_id'];

      //Loput arraysta tytettv tyhjll tiedolla jotta ei tule index virheit nkymss viitattaessa
      $formdata['TargetClient']['campaign_id'] = NULL;
      $formdata['LatestEvent']['contact_email_address'] = NULL;
      $formdata['LatestEvent']['contact_name'] = NULL;
      $formdata['LatestEvent']['contact_title'] = NULL;
      $formdata['TargetClient']['homepage'] = NULL;
      $formdata['TargetClient']['inoa_id'] = NULL;
      $formdata['LatestEvent']['contact_phone_number'] = NULL;
      $formdata['TargetClient']['exchange_number'] = NULL;
      $formdata['TargetClient']['address'] = NULL;
      $formdata['TargetClient']['domain'] = NULL;
      $formdata['TargetClient']['email_address'] = NULL;
      $formdata['User']['name'] = NULL;

      //Tehdn SQL query
      $result = $this->Campaign->checkNearHits($campaign_id, $y_id, $stripped);

      //Listn formin tiedot tulostaulun alkuun
      array_unshift($result, $formdata);

      //Listn viel to_be_added_id kaikille osumille
      for($i = 0; $i < sizeof($result); $i++) {
        $result[$i]['to_be_added_id'] = 0;
      }

      for($i = 0; $i < count($result); $i++) {
        $result[$i]['row_id'] = $i;
      }

      //Tallennetaan sessioon koko roska
      $this->Session->write("contact_info_for_saving", $result);

    }
    //jos lhde oli tiedosto, suoritetaan else
    else {
      $sourcefile = file($_FILES['csv_file_name']['tmp_name']);
      //Laskee mill rivill ollaan lhdetiedostossa
      $counter = 0;
      //Tarvitaan to_be_added_id:n lismiseen per yritys+lhiosumat
      $id_counter = 0;
      //Rivin rjyttmiseen tarvittava muuttuja
      $exploded;
      //Kertn lopullinen tulos thn
      $result;
      //Lopputulostaulun kokoamiseen tarvittava laskuri
      $ensimmainen_lisays = true;
       
      foreach($sourcefile as $row) {
        //Rjytetn rivi osiin
        $exploded[$counter] = explode(",", $row);
        //Parsitaan kohdeyrityksen nimest turhat merkit pois
        $stripped = $this->stripName($exploded[$counter][3]);
        $y_id = $exploded[$counter][4];

        //Tytetn arrayn solut tarvittavilla tiedoilla
        $formdata['TargetClient']['name'] = $exploded[$counter][3];
        $formdata['TargetClient']['y_id'] = $exploded[$counter][4];
        $formdata['LatestEvent']['contact_email_address'] = $exploded[$counter][0];
        $formdata['LatestEvent']['contact_name'] = $exploded[$counter][1];
        $formdata['LatestEvent']['contact_title'] = $exploded[$counter][2];
        $formdata['TargetClient']['homepage'] = $exploded[$counter][5];
        $formdata['TargetClient']['inoa_id'] = $exploded[$counter][6];
        $formdata['TargetClient']['exchange_number'] = $exploded[$counter][7];
        $formdata['LatestEvent']['contact_phone_number'] = $exploded[$counter][8];
        $formdata['TargetClient']['address'] = $exploded[$counter][9];
        $formdata['TargetClient']['domain'] = $exploded[$counter][10];
        $formdata['TargetClient']['email_address'] = $exploded[$counter][11];

        //Loput rivit tytetn NULLilla jottai ei tule index virheit nkymiss viitatessa
        $formdata['TargetClient']['campaign_id'] = null;
        $formdata['User']['name'] = null;
        //Yksi SQL-kysely per kohdeyritys
        $midresult = $this->Campaign->checkNearHits($campaign_id, $y_id, $stripped);
        //Listn formin tiedot tulostaulun alkuun
        array_unshift($midresult, $formdata);
        //Listn viel to_be_added_id kaikille osumille
        for($i = 0; $i < sizeof($midresult); $i++) {
          $midresult[$i]['to_be_added_id'] = $id_counter;
        }
        //Kasvatetaan counteria seuraava kohdeyritysrypst varten
        $id_counter++;
         
        if($ensimmainen_lisays == true) {
          $result = $midresult;
          $ensimmainen_lisays = false;
        }
        else {
          $lisayscounter = sizeof($result)+1;

          foreach($midresult as $row) {
            $result[$lisayscounter] = $row;
            $lisayscounter++;
          }
        }
      }

	  foreach($result as &$row) {
	  	$row['row_id'] = $rowcounter;
	  	$rowcounter++;
	  }

      //Tallennetaan sessioon koko roska
      $this->Session->write("contact_info_for_saving", $result);
       
    }

    //Annetaan nkymlle seuraavat muuttujat
    $this->set('for_user', $for_user);
    $this->set('after_save_path', $after_save_path);
    $this->set('campaign_id', $campaign_id);
    $this->set('scripts', array());

  }

    /**
   * Lis uudet kohdeasiakkaat kantaan
   *
   * @param int $campaign_id Kampanjan tunnistetieto
   * @param boolean $for_user Listnk kohdeasiakkaat kyttjlle (true/false)
   * @param string $after_save_path Url johon kyttj ohjataan tallennuksen jlkeen
   *
   */
  
  function addContact($campaign_id, $for_user, $after_save_path) {
  	
  	//Luetaan sessiosta lhiosumalista
	$nearhits = $this->Session->read("contact_info_for_saving");
	//Luetaan post parametrit muuttujaan
	$usersvalidations = $this->params['form'];
	//hillotaan user_id thn muuttujaan
	$user_id = false;
	//Luodaan viel yksi array mihin tiedot kertn ja sen avuksi counter
	$tmp_array = array();
	$tmpcounter = 0;
	$choise = false;
	//Tietojen kohdistamiseen tarvittava rivinumero
	$rownumber = 0;
	//Luetaan sessiosta user_id
	$user = $this->Session->read('user');
	
	foreach($usersvalidations as $row) {
		
		if($choise == true) {
			$tmp_array[$tmpcounter]['choise'] = $row;
			$choise = false;
			$tmpcounter++;
		}
		else {
			$tmp_array[$tmpcounter]['row'] = $row;
			$choise = true;
		}
		
	}
	$usersvalidations = $tmp_array;

	foreach($usersvalidations as $row) {

	  switch($row['choise']) {
        case "-1":
          while($nearhits[$rownumber]['to_be_added_id'] != $row['row']) {
          	$rownumber++;
          }
          $this->Campaign->saveContact($nearhits[$rownumber], $campaign_id, "", $user['id'], $for_user);
          break;
        case "-2":
          break;
        default:
          while($nearhits[$rownumber]['to_be_added_id'] != $row['row']) {
          	$rownumber++;
          }
          $this->Campaign->saveContact($nearhits[$rownumber], $campaign_id , $row['choise'], $user['id'], $for_user);
		  break;
      }
      $rownumber = 0;

	}
//	echo $after_save_path;
	$this->Redirect('/campaigns/index/' . $campaign_id);
	exit();

  }

  /**
   * Privaatti funktio joka parsii stringist pois
   * turhat merkijonot (oy, ab, ky, tmi, oyj, abp, osk, ltd, ry).
   * Mikli parsimisten jlkeen nimen pituus on nelj merkki tai vhemmin,
   * palautetaan se suoraan, muutoin parsitaan nime viel siten ett palautetaan
   * vain nelj ensimmist merkki.
   *
   * @param string $tobestripped parsittava nimi
   * @return string $stripped parsittu nimi
   */
  private function stripName($tobestripped) {

    //Parsittu string
    $tobestripped;
    $stripped;

    //Etsittvt merkkijonot
    $yhtiomuotolyhenne = array("oyj","oy","ab","ky","tmi",
    "abp","osk","ltd","ry");

    //Kytetn kun poistetaan tyhji merkkej
    $yhdiste;

    $tobestripped = strtolower($tobestripped);

    foreach ($yhtiomuotolyhenne as $lyhenne) {

      $pos = strpos($tobestripped, $lyhenne);

      //Tutkiminen pit tehd nin koska strpos voi palauttaa false tai numeroarvon
      if($pos === false) {}
      else {
        //Jos ollaan stringin alussa
        if($pos == 0) {
          if(substr($tobestripped,$pos+strlen($lyhenne),1) == " ") {
            //Pistetn pern " " jotta tyhj vli poistuu
            $yhdiste = $lyhenne . " ";
            $tobestripped = str_replace($yhdiste, "", $tobestripped);
          }
        }
        //Jos ollaan muualla kuin alussa stringi
        else {
          //Jos ollaan stringin lopussa
          if($pos + strlen($lyhenne) >= strlen($tobestripped)) {
            if(substr($tobestripped,$pos-1,1) == " ") {
              $yhdiste = " " . $lyhenne;
              $tobestripped = str_replace($yhdiste, "", $tobestripped);
            }
          }
          //Jos ollaan keskell stringi
          else {
            if(substr($tobestripped,$pos+strlen($lyhenne),1) == " " && substr($tobestripped,$pos-1,1) == " ") {
              $yhdiste = $lyhenne . " ";
              $tobestripped = str_replace($yhdiste, "", $tobestripped);
            }
          }
        }
      }
    }
    //Mikli yrityksen nimi parsimisten jlkeen on COMPANY_NAME_MAX_SIZE (CONST) merkki tai alle, palautetaan se suoraan
    if(strlen($tobestripped) <= MYVA_CONST::COMPANY_NAME_MAX_SIZE) {
      $stripped = $tobestripped;
      return $stripped;
    }
    //Muutoin lyhennetn nimi neljn merkkiin (Otetaan vain nelj ekaa merkki)
    else {
      $tobestripped = substr($tobestripped, 0, 4);
      $stripped = $tobestripped;
      return $stripped;
    }
  }

  /**
   * Etsii kyttjasiakkaan kampanjasta/kampanjoista kontakteja
   * annetuilla tiedoilla
   *
   * @param postarray $data Hakuehdot
   * <ul>
   *   <li>[Campaign][id] int Kampanjan tunnistetieto</li>
   *   <li>[TargetClient][name] string Kohdeasiakkaan nimi</li>
   *   <li>[TargetClient][exchange_number] string Yhteyshenkiln puhelinnumero tai kohdeasiakkaan vaihteen puhelinnumero.</li>
   *   <li>[Event][contact_name] string Yhteyshenkiln nimi</li>
   *   <li>[TargetClient][y_id] string Kohdeasiakkaan Y-tunnus</li>
   * </ul>
   *
   */

  function searchContacts() {
    //jos yritetn kutsua ilman post-dataa, lopetetaan heti 
    if(!isset($this->params['form']['data'])) {
      exit();
    }
    $data = $this->params['form']['data'];

    $user = $this->Session->read('user');
    $user_id = $user['id'];
     
    $search_result;

    //Alustetaan kentt tyhjiksi
    // minne noi nimet kuuluisi oikaista
    $search_result[0]['Campaign']['id'] = NULL;
    $search_result[0]['Campaign']['name'] = NULL;
    $search_result[0]['TargetClient']['name'] = NULL;
    $search_result[0]['TargetClient']['id'] = NULL;
    $search_result[0]['TargetClient']['exchange_number'] = NULL;
    $search_result[0]['TargetClient']['y_id'] = NULL;
    $search_result[0]['Event']['contact_name'] = NULL;
    $search_result[0]['Event']['contact_phone_number'] = NULL;
    $search_result[0]['User']['name'] = NULL;
     
    //Tarkistetaan onko jossakin kentss tietoa
    if(empty($data['TargetClient']['name']) &&
    empty($data['TargetClient']['exchange_number']) &&
    empty($data['TargetClient']['y_id']) &&
    empty($data['Event']['contact_name'])
    ) {
      //Jos tietoa ei ollut, tallennetaan tyhj $search_result nkym varten
      $this->set('search_result', $search_result);
    }
    //Mikli jostain kentst lytyi tietoa, suoritetaan else-haara
    else {
       
      //Sanitoidaan sytteet:
      $data['Campaign']['id'] = $this->sanitizer->sql($data['Campaign']['id']);
      $data['Event']['contact_name'] = $this->sanitizer->sql($data['Event']['contact_name']);
      $data['TargetClient']['name'] = $this->sanitizer->sql($data['TargetClient']['name']);
      $data['TargetClient']['exchange_number'] = $this->sanitizer->sql($data['TargetClient']['exchange_number']);
      $data['TargetClient']['y_id'] = $this->sanitizer->sql($data['TargetClient']['y_id']);

      $valid_test = true;

      //Tarkistetaan ett y-tunnus ja puhelinnumero sisltvt vain sallittuja merkkej
      if(!empty($data['TargetClient']['y_id'])) {
        $valid_test = preg_match(VALID_YID, $data['TargetClient']['y_id']);
      }
      if(!empty($data['TargetClient']['exchange_number']) && $valid_test)
      $valid_test = preg_match(VALID_PHONE_NUMBER, $data['TargetClient']['exchange_number']);
      if($valid_test == true) {
        //Suoritetaan query annetulla datalla
        $search_result = $this->Campaign->searchContacts($data, $user_id);

        //Tallennetaan tulos nkym varten
        $this->set('search_result', $search_result);
      }
      else {
        //Koska testit eivt menneet yll lpi, asetetaan tyhj $search_result nkymlle
        $search_result = null;
        $this->set('search_result', $search_result);
      }
    }
    $this->render('searchContacts', 'ajax');
  }


  /**
   * Tuottaa myyjn raportit-sivun.
   *
   * @param int $campaign_id Aktiivisen kampanjan tunnistetieto.
   * @param postarray $data Lomakkeen tiedot.
   * <ul>
   *   <li>['Report']['start_time'] DateString = null. Rajauksen aloitusaika.</li>
   *   <li>['Report']['end_time'] DateString = null. Rajauksen lopetusaika.</li>
   *   <li>['Report']['save'] string Jos muuttuja on olemassa, tiedot tallennetaan.
   *   <li>['CampaignsUser']['calls_per_day'] int Kyttjn asettama soittoja pivss -tavoite.
   * </ul>
   */
  function userCampaignReport($campaign_id = -1) {
    // TODO: Kesken
    $campaign = false;
    $emaileventtypes = false;
    $clienteventtypes = false;
    $states = false;
    $classifications = false;
    $starttime = null;
    $endtime = null;

    $current_user = $this->Session->read('user');

    // Jos kampanjan tunniste on laiton (esim. vrn muotoinen tai eri kyttjasiakkaan), asetetaan se -1:ks
    if (! is_numeric($campaign_id)
    || $this->CampaignsUser->findCount(array(
    'CampaignsUser.user_id' => $current_user['id'],
    'CampaignsUser.campaign_id' => $campaign_id
    )) < 1
    ) {
      $campaign_id = -1;
    }

    if (!empty($this->data['Report']['start_time'])) {
      if (preg_match(VALID_DATETIME, $this->data['Report']['start_time'])) {
        $starttime = $this->Campaign->timeToDbDateTime(trim($this->data['Report']['start_time']));
        if ($starttime > date("Y-m-d H:i:s", time())) {
          $this->Campaign->invalidate('time');
          $error = true;
        }
      } else{
        $this->Campaign->invalidate('time');
      }
    }

    if (!empty($this->data['Report']['end_time'])) {
      if (preg_match(VALID_DATETIME, $this->data['Report']['end_time'])) {
        $endtime = $this->Campaign->timeToDbDateTime(trim($this->data['Report']['end_time']));
        if ( $endtime > date("Y-m-d H:i:s", time())) {
          $this->Campaign->invalidate('time');
          $error = true;
        }
      } else{
        $this->Campaign->invalidate('time');
      }
    }

    if ($endtime <  $starttime){
      $this->Campaign->invalidate('time');
      $error = true;
    }

    if (!empty($this->data['Report']['user'])) {
      $selected_user_id = $this->data['Report']['user'];
      $userlimit = " AND events.user_id = ' . $selected_user_id . ' ";
    }

    //tallennetaan
    if (!empty($this->data['Report']['save'])) {
      // Varmistetaan, ett id on oikea ja kuuluu tlle asiakkaalle ja thn kampanjaan
      $campaignsuser_check = $this->Campaign->findById($current_user['id']);
      //if ($campaign_check['Campaign']['campaign_id'] <> $campaign_id){
      // campaign ei kuulu tlle kyttjlle
      //TODO ulos
      //}
      $campaignsuser['CampaignsUser']['calls_per_day'] = $this->data['CampaignsUser']['calls_per_day'];
      $campaignsuser['CampaignsUser']['id'] = $current_user['id'];
      // Koitetaan tallentaa
      if (!$this->CampaignsUser->save($campaignsuser)){
        // Jos eponnistuu, niin ilmeisesti pitisi palauttaa kamat nkymn virheiden kera
      }
    }

    // Jos valittu jokin kampanja, haetaan sen tiedot.
    if ($campaign_id >= 0) {
      $campaign = $this->Campaign->find(
      array('Campaign.id' => $campaign_id, 'Campaign.user_client_id' => $current_user['user_client_id']),
      array('Campaign.*'),
      null,
      0
      );

      $emaileventtypes = $this->Event->getClientEventTypesReport($current_user['id'],$campaign_id,array('Viesti'),$starttime,$endtime);
      $clienteventtypes = $this->Event->getClientEventTypesReport($current_user['id'],$campaign_id,array('Soitto'),$starttime,$endtime);
      $states = $this->TargetClient->getTargetClientStatesReport($current_user['id'],$campaign_id,$starttime,$endtime);
      $classifications = $this->ClassificationsTargetClients->getTargetClientsClassificationReport($current_user['id'],$campaign_id,$starttime,$endtime);
      $needtoaccomblished = $this->TargetClient->getTargetClientsNeeded($current_user['id'],$campaign_id,$starttime,$endtime);

      $usercampaigns = $this->CampaignsUser->query('
        SELECT CampaignsUsers.*
          FROM campaigns_users AS CampaignsUsers
          WHERE CampaignsUsers.campaign_id = ' . $campaign_id . '
            AND CampaignsUsers.user_id = ' . $current_user['id'] . ' 
    ');
      $type = "'Soitto'";
      $callstotal = $this->TargetClient->query('
        SELECT COUNT(*) as lkm
               FROM target_clients, events
               WHERE target_clients.campaign_id = ' . $campaign_id . '
               AND events.target_client_id = target_clients.id
		 AND events.user_id = ' . $current_user['id'] . ' 
               AND events.event_type_id IN
                  (SELECT event_types.id 
		     FROM event_types, event_type_classes_event_types, event_type_classes 
                   WHERE event_type_classes_event_types.event_type_id = event_types.id
                   AND event_type_classes.id = event_type_classes_event_types.event_type_class_id
		     AND event_type_classes.id = ' . $type . ')
    ');
      $targetclientamount = $this->TargetClient->query('
        SELECT COUNT(*) as lkm
          FROM target_clients 
          WHERE target_clients.campaign_id = ' . $campaign_id . '
            AND target_clients.id IN 
              (SELECT events.target_client_id
               FROM target_clients, events
               WHERE target_clients.campaign_id = ' . $campaign_id . '
               AND events.target_client_id = target_clients.id
		 AND events.user_id = ' . $current_user['id'] . ' 
              )
    ');

      $needtotargetamount = $targetclientamount[0][0]['lkm'] - $usercampaigns[0]['CampaignsUsers']['target_amount'] - $usercampaigns[0]['CampaignsUsers']['accomplished_amount'];

    }
    if ($emaileventtypes === false) {
      $emaileventtypes = array();
    }
    if ($clienteventtypes === false) {
      $clienteventtypes = array();
    }
    if ($states === false) {
      $states = array();
    }
    if ($classifications === false) {
      $classifications = array();
    }

    $this->set('campaign_id', $campaign_id);
    $this->set('limit_start_time', $starttime);
    $this->set('limit_end_time', $endtime);
    $this->set('calls_total', $callstotal[0][0]['lkm']);
    $this->set('emails_report', $emaileventtypes);
    $this->set('client_event_types_report', $clienteventtypes);
    $this->set('client_count', $targetclientamount[0][0]['lkm']);
    $this->set('target_amount', $campaign['Campaign']['target_amount']);
    $this->set('accomblished_amount', $usercampaigns[0]['CampaignsUsers']['accomplished_amount']);
    $this->set('target_client_states_report', $states);
    $this->set('client_classifications_report', $classifications);
    $this->set('need_to_target_amount', $needtotargetamount);
    $this->set('need_to_accomblished', $needtoaccomblished);
    $this->set('calls_per_day', $usercampaigns[0]['CampaignsUsers']['calls_per_day']);
    $this->set('calls_per_day_suggestion', $usercampaigns[0]['CampaignsUsers']['calls_per_day_suggestion']);
    //$this->set('calls_contacted', $callscontacted);
    //$this->set('clients_finished', $clientsfinished);
    //$this->set('clients_accomplished', $clientsaccomplished);
    //$this->set('days_left', $daysleft);
    //$this->set('calls_total_target', $callstotaltarget);
    //$this->set('calls_contacted_target', $callscontactedtarget);
    //$this->set('clients_finished_target', $clientsfinishedtarget);
    //$this->set('clients_accomplished_target', $clientsaccomplishedtarget);
    //$this->set('optimal_reach', $optimalreach);
    //$this->set('optimal_accomplish_time', $optimalaccomplishtime);
    //$this->set('optimal_calls_per_day', $optimaalcallsperday);
    //$this->set('time_frame', $timeframe);
    $this->set('styles', array('campaigns/campaignReport', '../js/jscalendar/calendar-win2k-1'));
    $this->set('scripts', array(
    'jscalendar/calendar',
    'jscalendar/lang/calendar-fi',
    'jscalendar/calendar-setup'
    ));
  }

  /**
   * Tuottaa kaikkiraportti-sivun.
   *
   * @param int $campaign_id Aktiivisen kampanjan tunnistetieto.
   * @param postarray $data Hakuehdot ja suppilo.
   * <ul>
   *   <li><li>['Report']['user'] int Kyttjn tunnistetieto. Arvo -1 palauttaa kaikkien kyttjien tiedot.</li>
   *   <li>['Report']['start_time'] DateString = null. Rajauksen aloitusaika.
   *   <li>['Report']['end_time'] DateString = null. Rajauksen lopetusaika.
   *   <li>['Report']['save'] string Jos muuttuja on olemassa, tiedot tallennetaan.
   * </ul>
   */
  function campaignReport($campaign_id = -1) {
    // Tarkistetaan laittomat parametrit
    if ($campaign_id == -1 || !is_numeric($campaign_id)){
      $this->set('virhe', 'Kampanjaparametri virheellinen');
      $this->set('styles', array('campaigns/error'));
      $this->render('errors');
      exit;
    }

    // TODO: Kesken
    $campaign = null;
    $emaileventtypes = false;
    $clienteventtypes = false;
    $states = false;
    $classifications = false;
    $emaillinksreport = false;
    $usercampaigns = false;
    $userdetails = false;
    $starttime = null;
    $endtime = null;
    $selected_user_id = -1;
    $userlimit = "";
    $error = false;
    $callstotal = 0;
    $needtotargetamount = 0;
    $needtoaccomplished = 0;
    $targetclientamount = 0;

    $current_user = $this->Session->read('user');

    // Jos kampanjan tunniste on laiton (esim. vrn muotoinen tai eri kyttjasiakkaan), asetetaan se -1:ks
    if (! is_numeric($campaign_id)
    || $this->CampaignsUser->findCount(array(
    'CampaignsUser.user_id' => $current_user['id'],
    'CampaignsUser.campaign_id' => $campaign_id
    )) < 1
    ) {
      $campaign_id = -1;
    }

    if (!empty($this->data['Report']['start_time'])) {
      if (preg_match(VALID_DATETIME, $this->data['Report']['start_time'])) {
        $starttime = $this->Campaign->timeToDbDateTime(trim($this->data['Report']['start_time']));
        if ($starttime > date("Y-m-d H:i:s", time())) {
          $this->Campaign->invalidate('time');
          $error = true;
        }
      } else{
        $this->Campaign->invalidate('time');
      }
    }

    if (!empty($this->data['Report']['end_time'])) {
      if (preg_match(VALID_DATETIME, $this->data['Report']['end_time'])) {
        $endtime = $this->Campaign->timeToDbDateTime(trim($this->data['Report']['end_time']));
        if ( $endtime > date("Y-m-d H:i:s", time())) {
          $this->Campaign->invalidate('time');
          $error = true;
        }
      } else{
        $this->Campaign->invalidate('time');
      }
    }

    if ($endtime <  $starttime){
      $this->Campaign->invalidate('time');
      $error = true;
    }

    if (!empty($this->data['Report']['user'])) {
      $selected_user_id = $this->data['Report']['user'];
      $userlimit = " AND events.user_id = ' . $selected_user_id . ' ";
    }

    //tallennetaan
    if (!empty($this->data['Report']['save']) && !$error) {
      // Varmistetaan, ett id on oikea ja kuuluu tlle asiakkaalle ja thn kampanjaan
      $campaign_check = $this->Campaign->findById($campaign_id);
      //if ($campaign_check['Campaign']['campaign_id'] <> $campaign_id){
      // campaign ei kuulu tlle kyttjlle
      //TODO ulos
      //}
      $campaign['Campaign']['target_amount'] = $this->data['Campaign']['target_amount'];
      $campaign['Campaign']['accomplished_amount'] = $this->data['Campaign']['accomplished_amount'];
      $campaign['Campaign']['id'] = $campaign_id;
      // Koitetaan tallentaa
      if (!$this->Campaign->save($campaign)){
        // Jos eponnistuu, niin ilmeisesti pitisi palauttaa kamat nkymn virheiden kera
      }
      for($i = 0; $i < sizeof($this->data) - 2; $i++) {
        $campaignsuser['CampaignsUser']['target_amount'] = $this->data[$i]['target_amount'];
        $campaignsuser['CampaignsUser']['accomplished_amount'] = $this->data[$i]['accomplished_amount'];
        $campaignsuser['CampaignsUser']['calls_per_day_suggestion'] = $this->data[$i]['calls_per_day_suggestion'];
        $campaignsuser['CampaignsUser']['id'] = $this->data[$i]['id'];
        // Koitetaan tallentaa
        if (!$this->CampaignsUser->save($campaignsuser)){
          // Jos eponnistuu, niin ilmeisesti pitisi palauttaa kamat nkymn virheiden kera
        }
      }
    }


    // Jos valittu jokin kampanja, haetaan sen tiedot.
    if ($campaign_id >= 0) {
      $campaign = $this->Campaign->find(
      array('Campaign.id' => $campaign_id, 'Campaign.user_client_id' => $current_user['user_client_id']),
      array('Campaign.*'),
      null,
      0
      );
      $usercampaigns = $this->CampaignsUser->query('
        SELECT Users.id, Users.name, CampaignsUsers.id, CampaignsUsers.target_amount, CampaignsUsers.accomplished_amount, CampaignsUsers.calls_per_day, CampaignsUsers.calls_per_day_suggestion 
          FROM campaigns_users AS CampaignsUsers, users AS Users
          WHERE CampaignsUsers.campaign_id = ' . $campaign_id . '
            AND Users.id = CampaignsUsers.user_id
          ORDER BY Users.name
    ');
    }
    if ($campaign_id >= 0 && !$error) {
      $emaileventtypes = $this->Event->getClientEventTypesReport($selected_user_id,$campaign_id,array('Viesti'),$starttime,$endtime);
      $emaillinksreport = $this->Event->getEmailLinksReport($selected_user_id,$campaign_id,$starttime,$endtime);
      $clienteventtypes = $this->Event->getClientEventTypesReport($selected_user_id,$campaign_id,array('Soitto'),$starttime,$endtime);
      $states = $this->TargetClient->getTargetClientStatesReport($selected_user_id,$campaign_id,$starttime,$endtime);
      $classifications = $this->ClassificationsTargetClients->getTargetClientsClassificationReport($selected_user_id,$campaign_id,$starttime,$endtime);
      $needtoaccomplished = $this->TargetClient->getTargetClientsNeeded($selected_user_id,$campaign_id,$starttime,$endtime);
       
      $usercampaigns = $this->CampaignsUser->query('

        SELECT Users.id, Users.name, CampaignsUsers.id, CampaignsUsers.target_amount, CampaignsUsers.accomplished_amount, CampaignsUsers.calls_per_day, CampaignsUsers.calls_per_day_suggestion 
          FROM campaigns_users AS CampaignsUsers, users AS Users
          WHERE CampaignsUsers.campaign_id = ' . $campaign_id . '
            AND Users.id = CampaignsUsers.user_id
          ORDER BY Users.name
    ');

      $i= 0;
      foreach ($usercampaigns as $rivi) {
        $userdetail;
        $userdetail['Users']['id'] = $rivi['Users']['id'];
        $userdetail['Users']['name'] = $rivi['Users']['name'];
        $userdetail['CampaignsUsers']['id'] = $rivi['CampaignsUsers']['id'];
        $userdetail['CampaignsUsers']['target_amount'] = $rivi['CampaignsUsers']['target_amount'];
        $userdetail['CampaignsUsers']['accomplished_amount'] = $rivi['CampaignsUsers']['accomplished_amount'];
        $userstates = $this->TargetClient->getTargetClientStatesReport($rivi['Users']['id'],$campaign_id);
        $userdetail['CampaignsUsers']['accomplished_count'] = "0";
        foreach ($userstates as $userstate) {
          if ($userstate['TargetClient']['target_client_state_id'] == "Tavoite saavutettu") {
            $userdetail['CampaignsUsers']['accomplished_count'] = $userstate['TargetClient']['count'];
          }
        }
        $userdetail['CampaignsUsers']['reached_total'] = "0";
        $userclienteventtypes = $this->Event->getClientEventTypesReport($rivi['Users']['id'],$campaign_id,array('Soitto'));
        foreach ($userclienteventtypes as $userclienteventtype) {
          if ($userclienteventtype['Event']['event_type_id'] == "Tavoitettu") {
            $userdetail['CampaignsUsers']['reached_total'] = $userclienteventtype['Event']['count'];
          }
        }
        $userdetail['CampaignsUsers']['calls_per_day'] = $rivi['CampaignsUsers']['calls_per_day'];
        $userdetail['CampaignsUsers']['calls_per_day_suggestion'] = $rivi['CampaignsUsers']['calls_per_day_suggestion'];
        $userdetails[$i] = $userdetail;
        $i++;
      }
      $type = "'Soitto'";
      $calls = $this->TargetClient->query('

        SELECT COUNT(*) as lkm
               FROM target_clients, events
               WHERE target_clients.campaign_id = ' . $campaign_id . '
               AND events.target_client_id = target_clients.id'
		       . $userlimit . '
               AND events.event_type_id IN
                  (SELECT event_types.id 
		             FROM event_types, event_type_classes_event_types, event_type_classes 
                    WHERE event_type_classes_event_types.event_type_id = event_types.id
                      AND event_type_classes.id = event_type_classes_event_types.event_type_class_id
		              AND event_type_classes.id = ' . $type . ')
    ');

      $callstotal = $callstotal[0][0]['lkm'];
      $targetclientamounts = $this->TargetClient->query('

        SELECT COUNT(*) as lkm
          FROM target_clients 
          WHERE target_clients.campaign_id = ' . $campaign_id . '
            AND target_clients.id IN 
              (SELECT events.target_client_id
               FROM target_clients, events
               WHERE target_clients.campaign_id = ' . $campaign_id . '
               AND events.target_client_id = target_clients.id '
		 . $userlimit . '
              )
    ');

      $targetclientamount = $targetclientamounts[0][0]['lkm'];
      $needtotargetamount = $targetclientamounts[0][0]['lkm'] - $usercampaigns[0]['CampaignsUsers']['target_amount'] - $usercampaigns[0]['CampaignsUsers']['accomplished_amount'];
    }

    if ($emaileventtypes === false) {
      $emaileventtypes = array();
    }
    if ($clienteventtypes === false) {
      $clienteventtypes = array();
    }
    if ($states === false) {
      $states = array();
    }
    if ($classifications === false) {
      $classifications = array();
    }
    if ($emaillinksreport === false) {
      $emaillinksreport = array();
    }
    if ($usercampaigns === false) {
      $usercampaigns = array();
    }
    if ($userdetails === false) {
      $userdetails = array();
    }

    $this->set('campaign_id', $campaign_id);
    $this->set('selected_user_id', $selected_user_id);
    $this->set('limit_start_time', $starttime);
    $this->set('limit_end_time', $endtime);
    $this->set('campaignsusers', $usercampaigns);
    $this->set('calls_total', $callstotal);
    $this->set('emails_report', $emaileventtypes);
    $this->set('email_links_report', $emaillinksreport);
    $this->set('client_event_types_report', $clienteventtypes);
    $this->set('client_count', $targetclientamount);
    $this->set('target_amount', $campaign['Campaign']['target_amount']);
    $this->set('accomplished_amount', $campaign['Campaign']['accomplished_amount']);
    $this->set('target_client_states_report', $states);
    $this->set('client_classifications_report', $classifications);
    $this->set('need_to_target_amount', $needtotargetamount);
    $this->set('need_to_accomplished', $needtoaccomplished);
    $this->set('calls_per_day', $usercampaigns[0]['CampaignsUsers']['calls_per_day']);
    $this->set('calls_per_day_suggestion', $usercampaigns[0]['CampaignsUsers']['calls_per_day_suggestion']);
    $this->set('user_details',$userdetails);
    //$this->set('calls_contacted', $callscontacted);
    //$this->set('clients_finished', $clientsfinished);
    //$this->set('clients_accomplished', $clientsaccomplished);
    //$this->set('days_left', $daysleft);
    //$this->set('calls_total_target', $callstotaltarget);
    //$this->set('calls_contacted_target', $callscontactedtarget);
    //$this->set('clients_finished_target', $clientsfinishedtarget);
    //$this->set('clients_accomplished_target', $clientsaccomplishedtarget);
    //$this->set('optimal_reach', $optimalreach);
    //$this->set('optimal_accomplish_time', $optimalaccomplishtime);
    //$this->set('optimal_calls_per_day', $optimaalcallsperday);
    //$this->set('time_frame', $timeframe);
    $this->set('styles', array('../js/jscalendar/calendar-win2k-1'));
    $this->set('scripts', array(
    'jscalendar/calendar',
    'jscalendar/lang/calendar-fi',
    'jscalendar/calendar-setup'
    ));
  }

  /**
   * Tuottaa kampanjan yllpitosivun ja pyydettess tallentaa sivulla olevien
   * kenttien arvot (Tallenna-painike).
   *
   * @param int $campaign_id Aktiivisen kampanjan tunnistetieto. Arvolla -1 uusi kampanja.
   * @param postarray $data Lomakkeen tiedot. Indeksien n.. ei tarvitse olla jatkuva numerosarja.
   * <ul>
   *   <li>[Campaign][name] String Kampanjan nimi.</li>
   *   <li>[Campaign][orderer] String Kampanjan tilaajan nimi.</li>
   *   <li>[Campaign][start_time] DateString Kampanjan alkamisaika muodossa pp.kk.vvvv.</li>
   *   <li>[Campaign][end_time] DateString Kampanjan pttymisaika muodossa pp.kk.vvvv.</li>
   *   <li>[Campaign][message_subject] String Kampanjaan liittyvn viestin otsikko.</li>
   *   <li>[Campaign][message] String Kampanjaan liittyv viesti html-muodossa.</li>
   *   <li>[SalesArgument][n..][SalesArgument][id] int Myyntiargumentin tunniste, jos myyntiargumentti on ennestn olemassa.</li>
   *   <li>[SalesArgument][n..][SalesArgument][argument] int Myyntiargumentin tunniste, jos myyntiargumentti on ennestn olemassa.</li>
   *   <li>[Classification][n..][Classification][id] int Luokittelutiedon tunniste, jos luokittelutieto on ennestn olemassa.</li>
   *   <li>[Classification][n..][Classification][classification] int Luokittelutiedon tunniste, jos luokittelutieto on ennestn olemassa.</li>
   *   <li>[users_not_in_campaign][n..][CampaignsUser][user_id] Kampanjasta poistettavan kyttjn tunnistetieto.</li>
   *   <li>[users_in_campaign][n..][CampaignsUser][id] Kampanjassa olevan kyttjn kampanjakohtainen tunnistetieto.</li>
   *   <li>[users_in_campaign][n..][CampaignsUser][user_id] Kampanjaan listtvn kyttjn tunnistetieto.</li>
   *   <li>[users_in_campaign][n..][CampaignsUser][phone_number] Kampanjan kyttjn kampanjakohtainen puhelinnumero.</li>
   *   <li>[users_in_campaign][n..][CampaignsUser][email_address] Kampanjan kyttjn kampanjakohtainen shkpostiosoite.</li>
   *   <li>[TargetClient][n..][TargetClient][id] Kohdeasiakkaan tunnistetieto, joka liitetn/poistetaan myyjlle. Indeksi n.. no kohdeasiakkaan tunnistetieto.</li> 
   *   <li>[TargetClient][n..][TargetClient][user_id] Kyttjn tunistetieto  (users-taulun, ei kampanjankohtainen), jolle kohdeasiakas liitetn. Jos tyhj, kohdeasiakas poistetaan myyjlt, jolle se ennestn kuului. Indeksi n.. no kohdeasiakkaan tunnistetieto.</li>
   * </ul>
   */
  function campaignManagement($campaign_id = -1) {
    /* TODO:
     * - Miten ei-aktiiviset myyjt?
     *   - Toteutettu: Ei-aktiiviset myyjt, joilla asiakkailla, nkyvt
     *   - Niiden selke erottelu aktiivisista puuttuu
     * - Samanaikaisen muokkauksen estminen
     */
    $this->params['data'] = &$this->params['form']['data'];
    $this->data = &$this->params['form']['data'];

    $user = $this->Session->read('user');

    $campaign = false;
    $sales_arguments = false;
    $classifications = false;
    $users_targets = false;
    $orphan_targets = false;

    $users = array();
    $invalid_sections = array(
      'any' => false,
      'Campaign' => false,
      'MessageLink' => false,
      'SalesArgument' => false,
      'Classification' => false,
      'users_not_in_campaign' => false,
      'users_in_campaign' => false,
      'orphan_targets' => false,
      'TargetClient' => array('any' => false)
    );

    $current_user = $this->Session->read('user');

    // Jos kampanjan tunniste on laiton (esim. vrn muotoinen tai eri kyttjasiakkaan), asetetaan se -1:ks
    if (! is_numeric($campaign_id)
    || (!$current_user['campaign_admin'] && $this->CampaignsUser->findCount(array(
    'CampaignsUser.user_id' => $current_user['id'],
    'CampaignsUser.campaign_id' => $campaign_id
    )) < 1)
    || ($current_user['campaign_admin'] && $this->Campaign->findCount(array(
    'Campaign.user_client_id' => $current_user['user_client_id'],
    'Campaign.id' => $campaign_id
    )) < 1)
    ) {
      $campaign_id = -1;
    }

    if (isset($this->params['form']['data'])) {
      $this->forStringsInArray($this->params['form']['data'], 'trim');
      $this->Campaign->execute('START TRANSACTION');

      $section = 'Campaign';
      if (isset($this->params['form']['data'][$section])) {
        // Tallenna kampanjan perustiedot
        $campaign = array($section => $this->params['form']['data'][$section]);
        $campaign[$section]['id'] = ($campaign_id < 0 ? null : $campaign_id);

        $user_start_time = $campaign[$section]['start_time'];
        $campaign[$section]['start_time'] = $this->Campaign->timeToDbDate($campaign[$section]['start_time']);
        $user_end_time = $campaign[$section]['end_time'];
        $campaign[$section]['end_time'] = $this->Campaign->timeToDbDate($campaign[$section]['end_time']);
        if (! $this->Campaign->validates($campaign[$section])) {
          $invalid_sections[$section] = true;
        }

        // Validoi kampanjan aloitusaika
        if (! preg_match(VALID_DATETIME, $user_start_time)) {
          $this->Campaign->invalidate('start_time');
          $invalid_sections[$section] = true;
        }

        // Validoi kampanjan lopetusaika
        $invalid_fields = $this->Campaign->invalidFields();
        if (! preg_match(VALID_DATETIME_OR_EMPTY, $user_end_time)
            || (! array_key_exists('start_time', $invalid_fields)
              && ! empty($campaign[$section]['end_time'])
              && $campaign[$section]['end_time'] < $campaign[$section]['start_time'])) {
          $this->Campaign->invalidate('end_time');
          $invalid_sections[$section] = true;
        }

        $campaign[$section]['user_client_id'] = $user['user_client_id'];
        $campaign[$section]['target_amount'] = 0;
        $campaign[$section]['accomplished_amount'] = 0;
        $invalid_sections[$section] = $invalid_sections[$section] || ! $this->Campaign->save($campaign[$section]);
        if (! $invalid_sections[$section]) {
          if ($campaign_id < 0) {
            $campaign_id = $this->Campaign->getLastInsertId();
          }
          if (! $this->MessageLink->parseMessage($campaign[$section]['message'], $campaign_id)) {
            $invalid_sections['MessageLink'] = true;
          }
        }
        if ($invalid_sections[$section]) {
          // Palautetaan alkuperiset tiedot parametritaulukkoon
          $campaign = array($section => $this->params['form']['data'][$section]);
          $campaign[$section]['id'] = ($campaign_id < 0 ? null : $campaign_id);
        }
        if ($invalid_sections[$section] || $invalid_sections['MessageLink']) {
          $invalid_sections['any'] = true;
        }
      }

      $section = 'SalesArgument';
      if (isset($this->params['form']['data'][$section])) {
        // Tallenna myyntiargumentit
        $sales_arguments = $this->params['form']['data'][$section];
        $invalid_sections[$section] = ! $this->saveTextOptionList($sales_arguments, $section, 'sales_arguments', 'argument', 'events', 'sales_argument_id', $campaign_id);
        if ($invalid_sections[$section]) {
          $invalid_sections['any'] = true;
        }
      }

      $section = 'Classification';
      if (isset($this->params['form']['data'][$section])) {
        // Tallenna luokittelutiedot
        $classifications = $this->params['form']['data'][$section];
        $invalid_sections[$section] = ! $this->saveTextOptionList($classifications, $section, 'classifications', 'classification', 'classifications_target_clients', 'classification_id', $campaign_id);
        if ($invalid_sections[$section]) {
          $invalid_sections['any'] = true;
        }
      }

      $section = 'users_in_campaign';
      if (isset($this->params['form']['data'][$section])) {
        // Lis ja pivitetn kyttjt kampanjaan
        // Tallennetaan transaktiossa validoimattomana kantaan, rollback jos validointi eponnistuu
        $this->forStringsInArray($this->data[$section], 'sql', $this->sanitizer);
        foreach (array_keys($this->data[$section]) as $key) {
          $users[$this->data[$section][$key]['CampaignsUser']['user_id']] = &$this->data[$section][$key];
          $this->CampaignsUser->validationErrors = array();
          if (empty($this->data[$section][$key]['CampaignsUser']['id'])) {
            // Listn uusi kyttj
            // Kuollaan pois, jos kyttj ei ole saman kyttjasiakkaan kyttj
            $tmpvar = $this->User->field('User.user_client_id',
            array('User.id' => $this->data[$section][$key]['CampaignsUser']['user_id']));
            if ($tmpvar === false || $tmpvar != $user['user_client_id']) {
              $this->Campaign->execute('ROLLBACK');
              $this->flash('Kyttj-id ' . $this->data[$section][$key]['CampaignsUser']['user_id'] . ' on virheellinen', $this->params['url']['url']);
              exit();
            }
            // Onko kyttj jo kampanjassa?
            $this->data[$section][$key]['CampaignsUser']['id'] = $this->CampaignsUser->field(
            'CampaignsUser.id',
            array(
            'CampaignsUser.user_id' => $this->data[$section][$key]['CampaignsUser']['user_id'],
            'CampaignsUser.campaign_id' => $campaign_id
            )
            );
            if (empty($this->data[$section][$key]['CampaignsUser']['id'])) {
              // Ei ollut ennestn kampanjassa, listn.
              $this->data[$section][$key]['CampaignsUser']['id'] = null;
              $this->data[$section][$key]['CampaignsUser']['campaign_id'] = $campaign_id;
              $this->data[$section][$key]['CampaignsUser']['target_amount'] = 0;
              $this->data[$section][$key]['CampaignsUser']['accomplished_amount'] = 0;
              $this->data[$section][$key]['CampaignsUser']['calls_per_day'] = 0;
              $this->data[$section][$key]['CampaignsUser']['calls_per_day_suggestion'] = 0;
              if (! $this->CampaignsUser->save(
              $this->data[$section][$key]['CampaignsUser'],
              false,
              array('id', 'user_id', 'campaign_id', 'phone_number', 'email_address',
              'target_amount', 'accomplished_amount', 'calls_per_day', 'calls_per_day_suggestion',
              'created', 'modified')
              )
              ) {
                $this->CampaignsUser->invalidate('id');
                $invalid_sections[$section] = true;
              }
            }
          }
          if (! empty($this->data[$section][$key]['CampaignsUser']['id'])) {
            // Pivitetn kyttjn tiedo
            $this->CampaignsUser->execute('
              UPDATE campaigns_users AS CampaignsUser
                SET phone_number = \'' . $this->data[$section][$key]['CampaignsUser']['phone_number'] . '\',
                  email_address = \'' . $this->data[$section][$key]['CampaignsUser']['email_address'] . '\',
                  modified = now()
                WHERE id = \'' . $this->data[$section][$key]['CampaignsUser']['id'] . '\'
                  AND user_id = \'' . $this->data[$section][$key]['CampaignsUser']['user_id'] . '\'
                  AND campaign_id = \'' . $campaign_id . '\'
            ');
            if ($this->CampaignsUser->getAffectedRows() != 1) {
              $this->CampaignsUser->invalidate('id');
              $invalid_sections[$section] = true;
            }
          }
          $invalid_sections[$section] = ! $this->CampaignsUser->validates($this->data[$section][$key]['CampaignsUser'])
            || $invalid_sections[$section];
          $this->data[$section][$key]['invalid_fields'] = $this->CampaignsUser->invalidFields();
          $invalid_sections[$section] = $invalid_sections[$section] || (! empty($this->data[$section][$key]['invalid_fields']));
        }

        $this->forStringsInArray($this->data[$section], 'stripslashes');
        if ($invalid_sections[$section]) {
          $invalid_sections['any'] = true;
        }
      }

      $section = 'TargetClient';
      if (isset($this->params['form']['data'][$section])) {
        // Siirretn yritykset myyjille/pois myyjilt
        // Haetaan ensin kampanjaan kuuluvat myyjt
        $campaign_users = $this->CampaignsUser->findAll(array('campaign_id' => $campaign_id));
        if ($campaign_users === false) {
          $invalid_sections[$section]['any'] = true;
        } else {
          // Tehdn kampanjan myyjist taulukko, jossa indeksin myyj-id
          // Asetetaan mys myyjkohtainen virhetaulukko
          $campaign_users_by_user_id = array();
          foreach (array_keys($campaign_users) as $key) {
            $campaign_users_by_user_id[$campaign_users[$key]['CampaignsUser']['user_id']] = &$campaign_users[$key];
            $invalid_sections[$section][$campaign_users[$key]['CampaignsUser']['user_id']] = false;
          }

          // Tallennetaan, mitk yritykset kuuluvat kenellekin kampanjan myyjlle
          $this->forStringsInArray($this->data[$section], 'sql', $this->sanitizer);
          foreach (array_keys($this->data[$section]) as $key) {
            $is_valid_user_id = true;
            $this->TargetClient->validationErrors = array();
            if (empty($this->data[$section][$key][$section]['user_id'])) {
              // Yritys poistetaan kyttjlt
              $this->data[$section][$key][$section]['user_id'] = '';
              $this->data[$section][$key][$section]['campaigns_user_id'] = 'null';
            } else if (isset($campaign_users_by_user_id[$this->data[$section][$key][$section]['user_id']]['CampaignsUser']['id'])) {
              // Yritys siirretn kyttjlle
              $this->data[$section][$key][$section]['campaigns_user_id'] = $campaign_users_by_user_id[$this->data[$section][$key][$section]['user_id']]['CampaignsUser']['id'];
            } else {
              $invalid_sections[$section][$this->data[$section][$key][$section]['user_id']] = true;
              $invalid_sections[$section]['any'] = true;
              $this->TargetClient->invalidate('campaigns_user_id');
              $users[$this->data[$section][$key][$section]['user_id']]['invalid_fields']['id'] = true;
              $is_valid_user_id = false;
            }
            if (empty($this->data[$section][$key][$section]['id'])) {
              $this->data[$section][$key][$section]['id'] = '';
            }
            
            if ($is_valid_user_id) {
              $this->TargetClient->execute('
                UPDATE target_clients
                  SET campaigns_user_id = ' . $this->data[$section][$key][$section]['campaigns_user_id'] .  '
                  WHERE id = \'' . $this->data[$section][$key][$section]['id'] .  '\'
                    AND campaign_id = ' . $campaign_id . '
              ');
              if ($this->TargetClient->getAffectedRows() != 1) {
                $invalid_sections[$section][$this->data[$section][$key][$section]['user_id']] = true;
                $invalid_sections[$section]['any'] = true;
                $this->TargetClient->invalidate('id');
              }
            }
            $this->data[$section][$key]['invalid_fields'] = $this->TargetClient->invalidFields();
          }
        }
        if ($invalid_sections[$section]['any']) {
          $invalid_sections['any'] = true;
        }
      }
      
      $section = 'users_not_in_campaign';
      if (isset($this->params['form']['data'][$section])) {
        $this->forStringsInArray($this->data[$section], 'sql', $this->sanitizer);
        // Poistetaan kampanjasta poistetut kyttjt

        // Luodaan sql-ehto poistettavista kyttjist tarkistusta varten
        $users_to_remove_sql = '';
        $separator = ' AND (';
        foreach (array_keys($this->params['form']['data'][$section]) as $key) {
          $users[$this->data[$section][$key]['CampaignsUser']['user_id']] = &$this->data[$section][$key];
          $this->data[$section][$key]['invalid_fields'] = array();
          if (! empty($this->data[$section][$key]['CampaignsUser']['user_id'])) {
            $users_to_remove_sql .= $separator . 'CampaignsUser.user_id = \'' . $this->data[$section][$key]['CampaignsUser']['user_id'] . '\'';
            $separator = ' OR ';
          }
        }
        if ($separator == ' OR ') {
          $users_to_remove_sql .= ')';
        }
        if (! empty($users_to_remove_sql)) {
          // Etsitn virheelliset poistettavat kyttj-id:t, ts
          // kyttj kuuluu eri kyttjasiakkaalle tai kyttjll on kampanjassa asiakkaita.
          // Tm vain virheilmoituksia varten, poistokysely ei huomioi virheellisi id:t.
          $result = $this->CampaignsUser->query('
            SELECT DISTINCT CampaignsUser.user_id
              FROM campaigns_users AS CampaignsUser
              WHERE 
                (
                  CampaignsUser.user_id NOT IN (
                    SELECT User.id
                      FROM users AS User
                      WHERE User.user_client_id = ' . $user['user_client_id'] . '
                  )
                  OR (
                    CampaignsUser.campaign_id = ' . $campaign_id . '
                    AND CampaignsUser.id IN (
                      SELECT TargetClient.campaigns_user_id
                        FROM target_clients AS TargetClient
                        WHERE TargetClient.campaign_id = CampaignsUser.campaign_id
                          AND TargetClient.campaigns_user_id IS NOT NULL
                    )
                  )
                )
          ' . $users_to_remove_sql);
          if ($result === false || ! empty($result)) {
            $invalid_sections[$section] = true;
          }
          $this->CampaignsUser->validationErrors = array();
          $this->CampaignsUser->invalidate('id');
          foreach ($result as $row) {
            $users[$row['CampaignsUser']['user_id']]['invalid_fields'] = $this->CampaignsUser->invalidFields();
          }

          // Luodaan sql-ehto poistettavista kyttjist poistamista varten
          $users_to_remove_sql = str_replace('CampaignsUser.', 'campaigns_users.', $users_to_remove_sql);
          // Poistetaan pyydetyt kyttjt, jotka kuuluvat kampanjaan ja joilla ei ole asiakkaita
          // Kysely ei tee virheellisille kyttjille mitn.
          $result = $this->CampaignsUser->execute('
            DELETE
              FROM campaigns_users
              WHERE campaigns_users.campaign_id = ' . $campaign_id . '
                AND campaigns_users.id NOT IN (
                  SELECT target_clients.campaigns_user_id
                    FROM target_clients
                    WHERE target_clients.campaign_id = campaigns_users.campaign_id
                      AND target_clients.campaigns_user_id IS NOT NULL
                )
          ' . $users_to_remove_sql);
          if ($result === false) {
            $invalid_sections[$section] = true;
          }
        }
        $this->forStringsInArray($this->data[$section], 'stripslashes');
        if ($invalid_sections[$section]) {
          $invalid_sections['any'] = true;
        }
      }
    }

    // Haetaan tietokannasta kampanjan tiedot
    if ($campaign_id >= 0) {
      if ($campaign === false) {
        // Jos valittu jokin kampanja, haetaan sen tiedot.
        $campaign = $this->Campaign->find(
        array('Campaign.id' => $campaign_id, 'Campaign.user_client_id' => $current_user['user_client_id']),
        array('Campaign.*'),
        null,
        0
        );
      }
      if ($sales_arguments === false) {
        $sales_arguments = $this->SalesArgument->query('
        SELECT SalesArgument.*, (
            SELECT SalesArgument.id IN (
              SELECT DISTINCT Event.sales_argument_id
                FROM events AS Event
                WHERE Event.sales_argument_id = SalesArgument.id
            )
          ) AS used
          FROM sales_arguments AS SalesArgument
          WHERE SalesArgument.campaign_id = ' . $campaign_id . '
          ORDER BY SalesArgument.argument ASC
        ');
      }
      if ($classifications === false) {
        $classifications = $this->Classification->query('
        SELECT Classification.*, (
            SELECT Classification.id IN (
              SELECT DISTINCT ClassificationsTargetClient.classification_id
                FROM classifications_target_clients AS ClassificationsTargetClient
                WHERE ClassificationsTargetClient.classification_id = Classification.id
            )
          ) AS used
          FROM classifications AS Classification
          WHERE Classification.campaign_id = ' . $campaign_id . '
          ORDER BY Classification.classification ASC
      ');
      }
    }
    $users_targets = $this->User->query('
    SELECT *
      FROM users AS User
        LEFT JOIN campaigns_users AS CampaignsUser ON (
          User.id = CampaignsUser.user_id
            AND CampaignsUser.campaign_id = ' . $campaign_id .  '
        )
      WHERE User.user_client_id = ' . $user['user_client_id'] . '
        AND (User.active_account = 1
          OR CampaignsUser.id IN (SELECT TargetClient.campaigns_user_id
            FROM target_clients AS TargetClient
          )
        )
      ORDER BY User.name ASC
    ');
    if ($users_targets !== false) {
      foreach (array_keys($users_targets) as $key) {
        if ($users_targets[$key]['CampaignsUser']['id'] !== null) {
          $users_targets[$key]['TargetClient'] = $this->TargetClient->query('
            SELECT TargetClient.*
              FROM target_clients AS TargetClient
              WHERE TargetClient.campaigns_user_id = ' . $users_targets[$key]['CampaignsUser']['id'] . '
              ORDER BY TargetClient.target_client_state_id ASC, TargetClient.name ASC
          ');
        } else {
          $users_targets[$key]['TargetClient'] = array();
        }
        if (isset($users[$users_targets[$key]['User']['id']]['invalid_fields'])) {
          $users_targets[$key]['invalid_fields'] = $users[$users_targets[$key]['User']['id']]['invalid_fields'];
        } else {
          $users_targets[$key]['invalid_fields'] = array();
        }
      }
    }
    if ($campaign_id >= 0) {
      $orphan_targets = $this->TargetClient->query('
      SELECT TargetClient.*, User.name
        FROM target_clients AS TargetClient
          LEFT JOIN (latest_events AS LatestEvent, users AS User)
            ON (LatestEvent.target_client_id = TargetClient.id
              AND LatestEvent.user_id = User.id
              AND LatestEvent.event_type_id != \'Luotu\')
        WHERE TargetClient.campaign_id = ' . $campaign_id . '
          AND TargetClient.campaigns_user_id IS NULL
        ORDER BY TargetClient.target_client_state_id ASC, User.name IS NULL ASC, User.name ASC, TargetClient.name ASC
      ');
    }

    if (isset($this->params['form']['data'])) {
      if ($invalid_sections['any']) {
        $this->Campaign->execute('ROLLBACK');
        $this->setInfoBar('Kampanjan tallentaminen eponnistui, tarkista kentt.', 'error');
      } else {
        $this->Campaign->execute('COMMIT');
        /*
         // Ei toimi, koska cake cachettaa:
         $this->setInfoBar('Kampanjan tiedot tallennettu.', 'success');
         $this->params['pass']['0'] = $campaign_id;
         $this->params['url']['url'] = '/' . $this->params['controller'] . '/' . $this->params['action'] . (empty($this->params['pass']) ? '' : '/') . implode('/', $this->params['pass']);
         $this->beforeFilter();
         */
        /*
         // Ei hyv, sill onnistumisviestin vlittminen hankalaa
         $this->Redirect('/campaigns/campaignManagement/' . $campaign_id);
         exit();
         */
        $this->params['pass']['0'] = $campaign_id;
        $this->params['url']['url'] = '/' . $this->params['controller'] . '/' . $this->params['action'] . (empty($this->params['pass']) ? '' : '/') . implode('/', $this->params['pass']);
        $this->flash('Kampanjan tiedot tallennettu.', $this->params['url']['url']);
      }
    }


    if ($campaign === false) {
      $campaign = array('Campaign' => array(
      'id' => '',
      'name' => '',
      'orderer' => '',
      'start_time' => $this->Campaign->timeToDbDate(time()),
      'end_time' => null,
      'message_subject' => '',
      'message' => '',
      'target_amoung' => 0,
      'created' => null,
      'modified' => null,
      'user_client_id' => $current_user['user_client_id']
      ));
    }
    if ($sales_arguments === false) {
      $sales_arguments = array();
    }
    if ($classifications === false) {
      $classifications = array();
    }
    if ($users_targets === false) {
      $users_targets = array();
    }
    if ($orphan_targets === false) {
      $orphan_targets = array();
    }

    if (empty($this->data)) {
      $this->params['form']['data'] = array();
      $this->params['data'] = &$this->params['form']['data'];
      $this->data = &$this->params['form']['data'];
    }
    $this->params['form']['data'] = array_merge($this->data, $campaign);
    $this->params['form']['data']['SalesArgument'] = $sales_arguments;
    $this->params['form']['data']['Classification'] = $classifications;


    $this->set('users_targets', $users_targets);
    $this->set('orphan_targets', $orphan_targets);
    $this->set('targets_count', $this->TargetClient->findCount(array('TargetClient.campaign_id' => $campaign_id)));
    $this->set('invalid_sections', $invalid_sections);
    $this->set('styles', array('../js/jscalendar/calendar-win2k-1'));
    $this->set('scripts', array(
    'src/scriptaculous',
    'swaptable',
    'fckeditor/fckeditor',
    'jscalendar/calendar',
    'jscalendar/lang/calendar-fi',
    'jscalendar/calendar-setup'
    ));
    if (DEBUG > 0) {
      $this->set('debug_output',
      '<h2>user</h2><pre>' . print_r($user, true) . '</pre>'
        . '<h2>params</h2><pre>' . print_r($this->params, true) . '</pre>'
        . '<h2>campaign</h2><pre>' . print_r($campaign, true) . '</pre>'
        . '<h2>sales_arguments</h2><pre>' . print_r($sales_arguments, true) . '</pre>'
        . '<h2>classifications</h2><pre>' . print_r($classifications, true) . '</pre>'
        . '<h2>users_targets</h2><pre>' . print_r($users_targets, true) . '</pre>'
        . '<h2>orphan_targets</h2><pre>' . print_r($orphan_targets, true) . '</pre>'
      );
    }
  }

  /**
   * Tallentaa TextOptionList:n muutokset.
   * Metodi olettaa tietokannan taulussa olevan id- ja campaign_id-nimiset kentt.
   * Palauttaa tiedon, onnistuiko tallentaminen.
   * Virhetilanteessa tallennetaan $list_data-tauluun mahdollinen virheilmoitus.
   *
   * @param array &$list_data Taulukko, josta TextOptionList:n tiedot luetaan ja johon muuttuneet tiedot tallennetaan
   * @param string $model Malli, johon tiedot tallennetaan (esim. SalesArgument).
   * @param string $table Tietokannan taulu, johon tiedot tallennetaan (esim. sales_arguments).
   * @param string $data_field Tietokannan taulun kentt, johon tiedot tallennetaan (esim. argument).
   * @param string $use_table Tietokannan taulu, jossa tallennettavaa tietoa kytetn (esim. events).
   * @param string $ref_field Kentn nimi $use_table -taulussa, jossa viitataan tallennettavaan tietoon (esim. sales_argument_id).
   * @param int $campaign_id Aktiivisen kampanjan tunniste.
   * @return true jos tallentaminen onnistui, muutoin false.
   */
  private function saveTextOptionList(&$list_data, $model, $table, $data_field, $use_table, $ref_field, $campaign_id) {
    // Jos kampanjan tunniste < 0, ei yritet tallentaa mitn.
    $success = true;
    $save = $campaign_id >= 0;

    // Ksitelln myyntiargumentit.
    $undo_data = array();
    foreach (array_keys($list_data) as $key) {
      //        $list_data[$key][$model][$data_field] = trim($list_data[$key][$model][$data_field]);
      if (empty($list_data[$key][$model]['id'])) {
        if (empty($list_data[$key][$model][$data_field])) {
          // Tyhj kentt, poistetaan tietorakenteesta.
          unset($list_data[$key]);
        } else if ($save && $success) {
          // Tallennetaan uusi myyntiargumentti.
          $undo_data[$key] = $list_data[$key];
          $list_data[$key][$model]['id'] = null;
          $list_data[$key][$model]['campaign_id'] = $campaign_id;
          if (! isset($list_data[$key][0])
          || ! is_array($list_data[$key][0])) {
            $list_data[$key][0] = array();
          }
          if ($this->$model->save($list_data[$key][$model], true, array('id', $data_field, 'created', 'modified', 'campaign_id'))) {
            $list_data[$key][$model]['id'] = $this->$model->getLastInsertId();
            $list_data[$key][0]['used'] = false;
          } else {
            $undo_data[$key]['error_message'] = 'Lisminen eponnistui:';
            $undo_data[$key][0]['used'] = false;
            $success = false;
          }
        } else {
          $list_data[$key][0]['used'] = false;
        }
      } else {
        $this->sanitizer->sql($list_data[$key][$model]['id']);
        $old_data = $this->$model->field($data_field, array(
          $model . '.id' => $list_data[$key][$model]['id'],
          $model . '.campaign_id' => $campaign_id
        ));
        if (!empty($old_data)) {
          if (empty($list_data[$key][$model][$data_field])) {
            // Poistetaan myyntiargumentti, jos ei kytss.
            $this->$model->execute('DELETE
                FROM ' . $table . '
                WHERE campaign_id = ' . $campaign_id . '
                  AND id = ' . $list_data[$key][$model]['id'] . '
                  AND id NOT IN (
                    SELECT ' . $ref_field . ' FROM ' . $use_table . '
                      WHERE ' . $ref_field . ' IS NOT NULL
                  )');
            if ($this->$model->getAffectedRows() > 0) {
              $list_data[$key]['0']['used'] = false;
              if ($success) {
                $undo_data[$key] = $list_data[$key];
                unset($list_data[$key]);
              }
            } else {
              $success = false;
              $list_data[$key]['error_message'] = 'Ei voi poistaa, on jo kytss:';
              $list_data[$key][$model][$data_field] = $old_data;
              $list_data[$key]['0']['used'] = true;
            }
          } else {
            if ($save && $success
            && $old_data != $list_data[$key][$model][$data_field]) {
              // Tallennetaan muuttunut myyntiargumentti.
              if (!$this->$model->save($list_data[$key][$model], true, array('id', $data_field, 'modified'))) {
                $success = false;
                $list_data[$key]['error_message'] = 'Muuttaminen eponnistui:';
              }
            }
            $data_used = $this->$model->query('
              SELECT ' . $model . '.id IN (
                SELECT DISTINCT ' . $use_table . '.' . $ref_field . '
                  FROM ' . $use_table . '
                  WHERE ' . $use_table . '.' . $ref_field . ' = ' . $model . '.id
                ) AS used
                FROM ' . $table . ' AS ' . $model . '
                WHERE ' . $model . '.campaign_id = ' . $campaign_id . '
                  AND ' . $model . '.id = ' . $list_data[$key][$model]['id'] .  '
              ');
            $list_data[$key] = array_merge($list_data[$key], $data_used[0]);
          }
        } else {
          // Virheellinen myyntiargumentin id.
          $success = false;
          $list_data[$key]['error_message'] = 'Virheellinen tunniste:';
        }
      }
    }
    
    if (!$success || !$save) {
      foreach (array_keys($undo_data) as $key) {
        $list_data[$key] = $undo_data[$key];
      }
    }

    return $success;
  }




  /**
   *     Tuottaa laskutustietosivulle kommentit-taulukon.
   *
   * @param int $user_id Kyttjn tunnistetieto.
   * @param int $campaign_id Kampanjan tunnnistetieto.
   * @param DateString $start_time = null. Rajauksen aloitusaika.
   * @param DateString $end_time = null. Rajauksen lopetusaika.
   */
  function getCampaignReport($user_id, $campaign_id, $start_time = null, $end_time = null) {
    // TODO:  viesti ??
    $campaign = false;
    $emailsreport = false;
    $emaillinksreport = false;
    $clienteventtypesreport = false;
    $targetclientstatesreport = false;
    $clientclassificationsreport = false;
    $username = "";
    //Kyttjn rajoitus kyselyiss
    $kayttajarajoitus = "";
    //Aikarajoitus kyselyiss
    $aikarajoitus = "";

    $current_user = $this->Session->read('user');

    // Jos kampanjan tunniste on laiton (esim. vrn muotoinen tai eri kyttjasiakkaan), asetetaan se -1:ks
    if (! is_numeric($campaign_id)
    || $this->CampaignsUser->findCount(array(
    'CampaignsUser.user_id' => $current_user['id'],
    'CampaignsUser.campaign_id' => $campaign_id
    )) < 1
    ) {
      $campaign_id = -1;
    }

    // Jos kampanjan tunniste on laiton (esim. vrn muotoinen tai eri kyttjasiakkaan), asetetaan se -1:ks
    if (! is_numeric($campaign_id)
    || $this->CampaignsUser->findCount(array(
    'CampaignsUser.user_id' => $current_user['id'],
    'CampaignsUser.campaign_id' => $campaign_id
    )) < 1
    ) {
      $campaign_id = -1;
    }

    //Mahdollinen kyttjrajoitus
    if ($user_id <> -1){
      $user = $this->User->find(
      array('User.id' => $user_id),
      array('User.name'),
      null,
      0
      );
      $username = $user['User']['name'];
      $kayttajarajoitus = "AND Event.user_id = $user_id";
    }

    //Mahdollinen aikarajoitus
    if ($start_time !== null && $end_time === null ){
      $aikarajoitus = "AND Event.start_time >= '$start_time'";
    } else if ($start_time !== null && $end_time !== null){
      $aikarajoitus = "AND Event.start_time BETWEEN '$start_time' AND '$end_time'";
    }

    // Jos valittu jokin kampanja, haetaan sen tiedot.
    if ($campaign_id >= 0) {
      $campaign = $this->Campaign->find(
      array('Campaign.id' => $campaign_id, 'Campaign.user_client_id' => $current_user['user_client_id']),
      array('Campaign.*'),
      null,
      0
      );
      $emailsreport = $this->Event->getClientEventTypesReport($user_id,$campaign_id,array('Viesti'),$start_time,$end_time);
      $emaillinksreport = $this->Event->getEmailLinksReport($user_id,$campaign_id,$start_time,$end_time);
      $clienteventtypesreport = $this->Event->getClientEventTypesReport($user_id,$campaign_id,array('Soitto'),$start_time,$end_time);
      $targetclientstatesreport = $this->TargetClient->getTargetClientStatesReport($user_id,$campaign_id,$start_time,$end_time);
      $clientclassificationsreport = $this->ClassificationsTargetClients->getTargetClientsClassificationReport($user_id,$campaign_id,$start_time,$end_time);

    }
    $this->set('limit_start_time', $start_time);
    $this->set('limit_end_time', $end_time);
    $this->set('limit_user_name', $username);
    $this->set('campaign_info', $campaign);
    $this->set('emails_report', $emailsreport);
    $this->set('email_links_report', $emaillinksreport);
    $this->set('client_event_types_report', $clienteventtypesreport);
    $this->set('target_client_states_report', $targetclientstatesreport);
    $this->set('client_classifications_report', $clientclassificationsreport);
    $this->set('target_amount', $campaign['Campaign']['target_amount']);
    $this->set('accomplished_amount', $campaign['Campaign']['accomplished_amount']);
  }

}

?>
