<?php
/**
 *CampaignsUsersController 
 * @author Ohjelmistotuotantoprojektiryhm myva, Helsingin yliopisto, Tietojenksittelytieteenlaitos
 * @version
 * @package myva
 * @subpackage Controllers
 */
class CampaignsUsersController extends AppController {

  var $name = 'CampaignsUsers';  
  var $helpers = array('html', 'time', 'time_fi', 'javascript', 'ajax');
  var $uses = array('Campaign','CampaignsUser', 'TargetClient', 'Event');
  
  /**
   * Luokan alustusfunktio. Asettaa metodit, joiden yhteydess nytetn valikot, tai jotka vaativat yllpitjn kyttoikeudet.  
   */
  function __construct (){
    parent::__construct();
//    $this->need_not_login = array();
//    $this->need_admin = array();
	
    $this->need_menus = array('showCampaignTargets');
  }
  


  /**
   * Luo ylvalikon.
   * 
   * @param string $request_path Valikossa aktiivisena olevan linkin polku. 
   */
  function getMenu($request_path) {

    $user = $this->Session->read('user');
  
    $request_path_parts = explode('/', urldecode($request_path));
    if (count($request_path_parts) >= 4 && is_numeric($request_path_parts[3])) {
      $campaign_id = $request_path_parts[3];
    } else {
      $campaign_id = -1;
    }
  
    $this->set('done', $this->CampaignsUser->getTargetClientsCount($campaign_id, $user['id'], 1));	  
    $this->set('not_done', $this->CampaignsUser->getTargetClientsCount($campaign_id, $user['id'],  0));
  
    // Etsitn, mik on pyydetty sivu)
    $page_id ='';  	  	  
    $page_ids = array_keys(MYVA_CONST::$MENU_PAGES);
    foreach($page_ids as $page_id_iterator) {
      if($request_path_parts[1] == MYVA_CONST::$MENU_PAGES[$page_id_iterator]['controller']
          && $request_path_parts[2] == MYVA_CONST::$MENU_PAGES[$page_id_iterator]['action']) {
        $page_id = $page_id_iterator;
        for ($i = 1; $i + 3 < count($request_path_parts) && $i < count(MYVA_CONST::$MENU_PAGES[$page_id_iterator]['pass']); ++$i) {
          if ($request_path_parts[$i + 3] != MYVA_CONST::$MENU_PAGES[$page_id_iterator]['pass'][$i]) {
            $page_id = '';
            break;
          }
        }
        if ($page_id != '') {
          break;
        }
      }  
    }

    // Viritys, jolla tunnistetaan soittosivu
    if ($request_path_parts[1] == 'events' && $request_path_parts[2] == 'getContactInfo') {
      $page_id = 'call';
    }
  
    $this->set('current_page_id', $page_id); // 
  
    $this->set('campaign_id', $campaign_id);
    if($campaign_id < 0) {
      $this->set('campaign_selected', false);
    } else {
      $this->set('campaign_selected', true);
    }
    $in_campaign = $this->CampaignsUser->field('id', array(
        'user_id' => $user['id'],
        'campaign_id' => $campaign_id
      )
    );
    $this->set('in_campaign', !empty($in_campaign));

    $this->render('getMenu', 'ajax');
  }

	


  function tulosta(){

    $this->set('posts', $this->CampaignsUser->findAll());

  }

  /**
   * Luo kampanjavalikon ja hakuikkunan. Metodi ei testaa, kuuluko parametrina annettu aktiivinen kampanja
   * kyttjlle vai ei. Jos ei kuulu, nkymn ei pid nytt mitn kampanjaa aktiiviseksi.
   * 
   * @param string $call_url Polku (muodossa controller/action/active_campaign/other_parameters),
   *   jota kutsuttiin ja jota varten kampanjavalikko luodaan. Oltava koodattu urlencode()-funktiolla.
   *   Ensimmisen parametrin on oltava aktiivisen kampanjan tunnistetieto tai -1.
   */
  function getUserCampaigns($call_url) {
    $user = $this->Session->read('user');
    $call_url_parts = explode('/', urldecode($call_url));

    if (count($call_url_parts) >= 4 && is_numeric($call_url_parts[3])) {
      $campaign_id = $call_url_parts[3];
    } else {
      $campaign_id = -1;
    }

//    if ($campaign_id < 0 
//          || $this->CampaignsUser->hasAny('campaign_id = ' . $campaign_id
//            . ' AND user_id = ' . $user['id'])) {
      $campaign_list = $this->CampaignsUser->getUserCampaigns(
        $user['id'],
        ($user['campaign_admin'] ? $user['user_client_id'] : -1)
      );
      $this->set('selected_campaign', $campaign_id);
      $this->set('call_url', $call_url_parts);
      $this->set('campaign_list', $campaign_list);
//    } else {
//      header("HTTP/1.0 404 Not Found");
//      exit();
//    }
  }
  
  
  /**
   * Tuottaa sek ksittelemttmt ett ksitellyt kohdeasiakkaat -sivut.
   * 
   * @param int $campaign_id = -1. Aktiivisen kampanjan tunnistetieto.
   * @param string $done = 'unfinished'. 'finished' = ksitellyt, 'unfinished' = ksittelemttmt
   */
  function showCampaignTargets($campaign_id = -1, $done = 'unfinished') {
    // TODO: Tysin kesken.
    // TODO: Tarkistus, mit tehdn, jos parametrit virheelliset
	/** Nytetnk shkpostin lhettminen nkymss*/
    $allow_email_sending = true;
    // Tarkistetaan parametrien riittvyys
    if(!is_numeric($campaign_id) || ($done <> 'unfinished' && $done <> 'finished')){
	  $this->flash('Virheellinen parametri', '/campaigns/index');
	  return;
	}	
    if ($campaign_id < 0) {
      $this->setInfoBar('Ole hyv ja valitse kampanja.', 'error');
      return;
    }
    $user = $this->Session->read('user');
    // Tsekataan onko kyttjll kyttoikeutta thn kampanjaan
	$campaigns_users_id = $this->TargetClient->getCampaignsUserId($user['id'], $campaign_id);
    
	if ($campaigns_users_id == null){
        $this->flash('Ei kyttoikeutta kampanjaan', '/campaigns/index');
	    return;
    }
    
    $campaign = $this->Campaign->findById($campaign_id);
    if ($campaign['Campaign']['start_time'] > date(Event::DB_DATE_FORMAT . ' ' . Event::DB_TIME_FORMAT, time()) || ($campaign['Campaign']['end_time']) <> null && $campaign['Campaign']['end_time'] < date(Event::DB_DATE_FORMAT . ' ' . Event::DB_TIME_FORMAT, time()) || $done == 'finished'){
      $allow_email_sending = false;
    }
    
    
    $client_count = $this->TargetClient->findCount(
      array(
        'CampaignsUser.user_id = ' . $user['id'],
        'CampaignsUser.campaign_id = ' . $campaign_id
      ), 1);
    $email_report = $this->Event->getClientEventTypesReport($user['id'], $campaign_id, array('Viesti'));
    $calls_today = $this->CampaignsUser->getCallsDoneToday($user['id'], $campaign_id);
    $calls_left = $this->CampaignsUser->getCallsPerDay($user['id'], $campaign_id) - $calls_today;

    $this->set('campaign_id', $campaign_id);
    $this->set('client_count', $client_count);
    $this->set('email_report', $email_report);
    $this->set('calls_today', $calls_today);
    $this->set('calls_left', $calls_left);
    $this->set('allow_email_sending', $allow_email_sending);
    if (DEBUG > 0) $this->set('debug_output',
      '<h2>$client_count</h2><pre>' . print_r($client_count, true) . '</pre>'
      . '<h2>$email_report</h2><pre>' . print_r($email_report, true) . '</pre>'
      . '<h2>$calls_today</h2><pre>' . print_r($calls_today, true) . '</pre>'
      . '<h2>$calls_left</h2><pre>' . print_r($calls_left, true) . '</pre>'
      . '<h2>$this-&gt;params</h2><pre>' . print_r($this->params, true) . '</pre>'
    );
  }


  /**
   *  Tuottaa kohdeasiakastaulukon ksittelemttmt ja ksitellyt -sivuille.
   * 
   * @param int $campaign_id = -1. Aktiivisen kampanjan tunnistetieto.
   * @param string $done = 'unfinished'. 'finished' = ksitellyt, 'unfinished' = ksittelemttmt
   */
  function getCampaignTargets($campaign_id = -1, $done = 'unfinished') {
    if(!is_numeric($campaign_id) || ($done <> 'unfinished' && $done <> 'finished')){
	  die('Virheellinen kutsu');
	  return;
	}	
    if ($campaign_id < 0) {      
      die('Virheellinen kutsu');
      return;
    }
    $user = $this->Session->read('user');
    // Tsekataan onko kyttjll kyttoikeutta thn kampanjaan
	$campaigns_users_id = $this->TargetClient->getCampaignsUserId($user['id'], $campaign_id);
    
	if ($campaigns_users_id == null){
        die('Virheellinen kutsu');
	    return;
    }
    $user = $this->Session->read('user');

    $target_client_list = $this->CampaignsUser->getCampaignList($user['id'],$campaign_id,  ($done == 'finished' ? 1 : 0));

    $this->set('campaign_id', $campaign_id);
    $this->set('target_client_list', $target_client_list);
    if (DEBUG > 0) $this->set('debug_output',
      '<h2>$target_client_list</h2><pre>' . print_r($target_client_list, true) . '</pre>'
      . '<h2>$this-&gt;params</h2><pre>' . print_r($this->params, true) . '</pre>'
    );
      
    $this->render('getCampaignTargets', 'ajax');
  }


  /**
   * Tuottaa miten menee? -ponnahdusikkunan.
   * 
   * @param int $campaign_id = -1. Aktiivisen kampanjan tunnistetieto.
   */
  function dailyReport($campaign_id = -1) {
    // TODO: kesken: todayn haku + usedworktime sessiosta? + kannustus
    $campaign = false;
    $encouragement = "";
    $current_user = $this->Session->read('user');
    
   //Toteutuneet:
    //Soitettujen puheluiden lkm.
    $callstoday = 0;
    //Paljonko puheluita tavoitteeseen
    $calls_left = 0;
//!! alempi ilmeisesti ylimrinen
    $callsneeded = 0;
    //Keskustelujen lkm
    $reachedtoday = 0;
    //Ksiteltyjen kohdeasiakkaiden lkm 
    $targetamount = 0;
    //"Tavoitte saavutettu"-asiakkaiden lkm
    $targetamountdone = 0;
    //Kytetty tyaika
    $usedworktime = "00:00"; //!!
    //Arvio ajasta joku kuluu tavoitteisiin psemiseksi
    $worktimeneeded = "00:00"; //!!
    
   //Tavoitteet:
    //Puheluiden tavoite lkm
    $calls_per_day_aim = 0;
    //Keskusteluiden tavoite lkm
    $target_amount_aim = 0;
    //"Tavoite saavutettu" tavoite lkm
    $accomplished_amount_aim = 0;

    
    
    

    // Jos kampanjan tunniste on laiton (esim. vrn muotoinen tai eri kyttjasiakkaan), asetetaan se -1:ksi
    if (! is_numeric($campaign_id)
        || $this->CampaignsUser->findCount(array(
            'CampaignsUser.user_id' => $current_user['id'],
            'CampaignsUser.campaign_id' => $campaign_id
          )) < 1
      ) {
      $campaign_id = -1;
    }

    // Jos valittu jokin kampanja, haetaan sen tiedot.
    if ($campaign_id >= 0) {
      $campaign = $this->Campaign->find(
        array('Campaign.id' => $campaign_id, 'Campaign.user_client_id' => $current_user['user_client_id']),
        array('Campaign.*'),
        null,
        0
      );

      //$encouragement = $this->UserProfile->getEncouragement($current_user['id']);
      $callstoday = $this->CampaignsUser->getCallsDoneToday($current_user['id'],$campaign_id);
      //$worktimeneeded = $this->CampaignsUser->getWorkHoursNeededToday($current_user['id'],$campaign_id);
      $calls_left = $this->CampaignsUser->getCallsPerDay($current_user['id'], $campaign_id) - $callstoday;
    
    $today = $this->TargetClient->query('SELECT CURDATE()');
    $today = $today[0][0]['CURDATE()'];
    // 
    $state = "'Tavoite saavutettu'"; 
    $targetamountdone = $this->TargetClient->query('
        SELECT COUNT(*) as lkm
          FROM target_clients 
          WHERE target_clients.campaign_id = ' . $campaign_id . '
            AND target_clients.target_client_state_id = ' . $state . '
            AND target_clients.id IN 
              (SELECT events.target_client_id
               FROM target_clients, events
               WHERE target_clients.campaign_id = ' . $campaign_id . '
               AND events.target_client_id = target_clients.id
               AND events.user_id = ' . $current_user['id'] . ' 
               AND events.start_time like \'' . $today . '%\'
              GROUP BY events.target_client_id)
    ');

    $state = "'Tavoitetta ei saavutettu'";
    $targetamount = $this->TargetClient->query('
        SELECT COUNT(*) as lkm
          FROM target_clients 
          WHERE target_clients.campaign_id = ' . $campaign_id . '
            AND target_clients.target_client_state_id = ' . $state . '
            AND target_clients.id IN 
              (SELECT events.target_client_id
               FROM target_clients, events
               WHERE target_clients.campaign_id = ' . $campaign_id . '
               AND events.target_client_id = target_clients.id
               AND events.user_id = ' . $current_user['id'] . ' 
               AND events.start_time like \'' . $today . '%\'
              GROUP BY events.target_client_id)
    ');

    $type = "'Tavoitettu'";
    $reachedtoday = $this->TargetClient->query('
        SELECT COUNT(*) as lkm
          FROM target_clients 
          WHERE target_clients.campaign_id = ' . $campaign_id . '
            AND target_clients.id IN 
              (SELECT events.target_client_id
               FROM target_clients, events
               WHERE target_clients.campaign_id = ' . $campaign_id . '
               AND events.target_client_id = target_clients.id
               AND events.user_id = ' . $current_user['id'] . ' 
               AND events.event_type_id = ' . $type . '
               AND events.start_time like \'' . $today . '%\'
              GROUP BY events.target_client_id)
    ');
    
    $targetamount = $targetamount[0][0]['lkm'] + $targetamountdone[0][0]['lkm']; 
    
    
    //tavoitteiden hakeminen
    $calls_per_day_aim = $this->CampaignsUser->query('SELECT calls_per_day FROM campaigns_users
                                                    WHERE user_id = ' . $current_user['id'] . 
                                                    ' AND campaign_id = ' . $campaign_id);
      $calls_per_day_aim = $calls_per_day_aim[0]['campaigns_users']['calls_per_day'];
    
    $target_amount_aim = $this->CampaignsUser->query('SELECT target_amount FROM campaigns_users
                                                    WHERE user_id = ' . $current_user['id'] . 
                                                    ' AND campaign_id = ' . $campaign_id);
      $target_amount_aim = $target_amount_aim[0]['campaigns_users']['target_amount'];
    
    $accomplished_amount_aim = $this->CampaignsUser->query('SELECT accomplished_amount FROM campaigns_users
                                                    WHERE user_id = ' . $current_user['id'] . 
                                                    ' AND campaign_id = ' . $campaign_id);
      $accomplished_amount_aim = $accomplished_amount_aim[0]['campaigns_users']['accomplished_amount'];
    
    }
    
    //toteutuneet
    $this->set('encouragement', $encouragement); 
    $this->set('calls_today', $callstoday);
    $this->set('calls_left', $calls_left);
    $this->set('reached_today', $reachedtoday[0][0]['lkm']);
    $this->set('target_amount', $targetamount);
    $this->set('target_amount_done', $targetamountdone[0][0]['lkm']);
    $this->set('used_worktime', $usedworktime); 
    $this->set('worktime_needed', $worktimeneeded);
    
    //tavoitteet
    $this->set('calls_per_day_aim' ,$calls_per_day_aim);
    $this->set('target_amount_aim', $target_amount_aim);
    $this->set('accomplished_amount_aim', $accomplished_amount_aim);
    
    
    $this->render('dailyReport', 'ajax');
  }  

  


}
?>