<?php
/**
 *EventsController
 * @author Ohjelmistotuotantoprojektiryhm myva, Helsingin yliopisto, Tietojenksittelytieteenlaitos
 * @version
 * @package myva
 * @subpackage Controllers
 */
class EventsController extends AppController {

  var $name = 'Events';

  var $uses = array('Event', 'EventType', 'EventTypesWithClass', 'Campaign', 'TargetClient', 'CampaignsUser', 'User', 'SalesArgument', 'Classification', 'TargetClientState', 'ClassificationsTargetClients', 'ReasonNoInterest', 'ClassificationsTargetClients', 'MessageLink','LatestEvent', 'EventsMessageLink');
   

  var $helpers = array('html', 'time', 'javascript', 'time_fi');


  /**
   * Luokan alustusfunktio. Luokan alustusfunktio. Asettaa metodit, joiden yhteydess nytetn valikot, tai jotka vaativat yllpitjn kyttoikeudet.
   */
  function __construct (){
    parent::__construct();
    //    $this->need_not_login = array();
    $this->need_admin = array('getContactInfo');
    $this->need_menus = array('getContactInfo');
  }

  /**
   * Valitsee automaattisesti seuraavan soiton kohdeasiakkaan. Suoritetaan
   * kun Soitto-painiketta on painettu tai jos kyttj valitsee soiton jlkeen tekevns
   * uuden soiton. Tekee tmn jlkeen uudelleenohjauksen soittosivulle.
   * Kun yhteydenotton jlkeen on painettu tallenna-painiketta, suoritetaan
   * metodi uudestaan mikli kyttj vastaa myntvsti kysymykseen siit,
   * otetaanko uusi yhteydenotto heti pern.
   * 
   * $param int $campaign_id Aktiivisen kampanjan tunnistetieto.
   */
  function chooseNextCall($campaign_id){
    $info = $this->Session->read('user');
    if (DEBUG > 0) print_r($info);
    $target_client_id = $this->Event->chooseNextCall($info['id'], $campaign_id);

    if($target_client_id == null){
      $this->flash("Sinulla ei ole yhtn kohdeasiakasta!", '/campaignsUsers/showCampaignTargets/'.$campaign_id.'/unfinished');
    }
    else{
      $this->redirect("/events/getContactInfo/" . $campaign_id . "/" . $target_client_id);
      exit();
    }
  }

  /**
   * Lhett shkpostia valituille kohdeasiakkaille ja ohjaa kyttjn tmn jlkeen toiselle sivulle, 
   * joka mritelln redirect_path muuttujassa.
   * 
   * @param int $campaign_id Aktiivisen kampanjan tunnistetieto.
   * @param postarray $data Valittujen kohdeasiakkaiden tunnistetiedot.
   * <ul>
   *   <li>[0..n]['TargetClient']['id'] int Kohdeasiakkaan tunnistetieto.</li>
   * </ul>
   * @param postarray $redirect Uudelleenohjauspolku.
   * <ul>
   *   <li>['form']['redirect'] string Uudelleenohjauksen suhteellinen polku postin lhettmisen jlkeen</li>
   * </ul>
   */
  function sendMail($campaign_id) {
    
    $user_info = $this->Session->read('user');
    $user_id = $user_info['id'];
    $user_name = $user_info['name'];
    $user_phone = $user_info['phone_number'];
    $send_ok=true;
    
    $lahtevat = array();
    $montako=0;

    $hakuarray = array("Campaign.id" => $campaign_id);
    $kampanja = $this->Campaign->find($hakuarray);
     
    $otsikko = $kampanja['Campaign']['message_subject'];
    $viesti = $kampanja['Campaign']['message'];
    $headers = 'From: '.$user_name . " <".$user_info['email_address']."> \r\n";
    $headers .= "Return-Path: <".$user_info['email_address']."> \r\n";
    $headers .= 'MIME-Version: 1.0' . "\r\n";
    $headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";

    $urlit = $this->MessageLink->query("SELECT target_url, id, beacon FROM message_links WHERE campaign_id=$campaign_id AND beacon=0",false);
    $beacon = $this->MessageLink->query("SELECT id FROM message_links WHERE campaign_id=$campaign_id AND beacon=1",false);
    
    if($this->data==null){
      $this->flash("Yhtn kohdeasiakasta ei ole valittu!", $this->params['form']['redirect']);   
      exit();
    }
    
    foreach($this->data as $tiedot) {
      
      $uusi_viesti=$viesti;
      $osoite;
      $last_id;
      $asiakas_id=$tiedot['TargetClient']['id'];
      
      $info = $this->LatestEvent->query("SELECT contact_email_address, contact_title,contact_name,contact_phone_number FROM latest_events
                                 WHERE target_client_id=$asiakas_id",false);
      if($info!=null) {
        $osoite = $info['0']['latest_events']['contact_email_address'];
        $name = $info['0']['latest_events']['contact_name'];
        $title = $info['0']['latest_events']['contact_title'];
        $phone = $info['0']['latest_events']['contact_phone_number'];

        $this->Event->execute("BEGIN WORK");
        if($this->Event->execute("INSERT INTO events (event_type_id,contact_email_address, start_time, end_time, contact_name, contact_title, contact_phone_number,  target_client_id, user_id, created, modified) VALUES
									   ('Lhetetty','$osoite', now(), now(), '$name', '$title', '$phone', $asiakas_id, $user_id, now(), now())", false)===false){
          $this->Event->execute("ROLLBACK");
          $send_ok=false;
          break;
        }
        else{
          $last_id=mysql_insert_id();
          $this->Event->execute("COMMIT");
        }
      }
      else{
        $send_ok=false;
        break;
      }
      
      if($send_ok!==false){
        foreach($urlit as $urls){
          $vaihdettava=$urls['message_links']['target_url'];
          $message_link_id=$urls['message_links']['id'];
        
          $temp=str_replace($vaihdettava,'temp',$viesti,$count);
            //ei tehd mitn, jos taulussa olevaa linkki ei lydy viestist
            if ($count > 0){
              $this->EventsMessageLink->execute("BEGIN WORK");
              $avain=sha1(microtime());
              $this->EventsMessageLink->execute("INSERT INTO events_message_links(id, event_count, message_link_id, user_event_id) 
                                                 VALUES ('$avain', 0, $message_link_id, $last_id)",false);
              if(mysql_errno()==0){
                $uusi_viesti=str_replace($vaihdettava, MYVA_CONFIG::EVENTS_MESSAGE_LINKS_URL.$avain ,$uusi_viesti);
                $this->EventsMessageLink->execute("COMMIT");
              }           
              else if(mysql_errno()!=0 && mysql_errno()!=1062){
                $send_ok=false;
                $this->EventsMessageLink->execute("ROLLBACK");
                $this->Event->execute("DELETE FROM events where id=$last_id",false);
                break;
              }
              //toiminta, jos avaimet trmvt
              else if(mysql_errno()==1062){
                $tries=5;
                $ok=false;
                while($ok===false){
                  sleep(1);
                  $avain=sha1(microtime());
                  $this->EventsMessageLink->execute("INSERT INTO events_message_links(id, event_count, message_link_id, user_event_id) 
                                                     VALUES ('$avain', 0, $message_link_id, $last_id)",false);
              
                  if(mysql_errno()==0){
                    $ok=true;
                    $this->EventsMessageLink->execute("COMMIT");
                    $uusi_viesti=str_replace($vaihdettava, MYVA_CONFIG::EVENTS_MESSAGE_LINKS_URL.$avain, $uusi_viesti);
                  
                  } else if($tries==0){
                      $this->EventsMessageLink->execute("ROLLBACK");
                      $send_ok=false;
                      $this->Event->execute("DELETE FROM events WHERE id=$last_id",false);
                      break;
                  }
                  $tries--;
                }
              }
            }
            if($send_ok===false){
              break;  
            }
         }
         //asetetaan majakka
         $avain=sha1(microtime());
         $beacon_id=$beacon['0']['message_links']['id'];
         if($this->EventsMessageLink->execute("INSERT INTO events_message_links(id, event_count, message_link_id, user_event_id) 
                                            VALUES ('$avain', 0, $beacon_id, $last_id)",false)===false){
           $send_ok=false;
           $this->Event->execute("DELETE FROM events WHERE id=$last_id",false);         
         }
         else{
           $uusi_viesti .= '<img src="'.MYVA_CONFIG::EVENTS_MESSAGE_LINKS_URL.$avain.'" alt="">';
         }
      }
      if($send_ok===true){
        $uusi_viesti = "<html><head></head><body>$uusi_viesti<p>Terveisin $user_name</br>Puh. $user_phone</p></body></html>";
	    $lahtevat[$montako] = (array ("mail" => $osoite, "viesti" => $uusi_viesti, "id" => $asiakas_id));
	    $montako++;
      }
      else{
        break;
      }  
    }
    
  	if($send_ok===false){
	  $this->flash("Virhe yritettess tallentaa tietokantaan, viestej ei lhetetty", $this->params['form']['redirect']);
	}
	else {
	  foreach($lahtevat as $rivi){
	    mail($rivi['mail'], $otsikko, $rivi['viesti'], $headers);
	    $id=$rivi['id'];
	    $this->TargetClient->execute("UPDATE target_clients SET target_client_state_id='Kesken' WHERE id=$id",false);
	  }
      $this->flash("Posteja lhetetty ".$montako." kpl", $this->params['form']['redirect']);
	}
  }

  /**
   *     Tuottaa laskutustietosivulle soittohistoria-taulukon.
   *
   * @param int $user_id Kampanjaan kuuluvan kyttjn tunnistetieto. Jos arvo -1,
   * tuotetaan raportti kaikista kyttjist.
   * @param int $campaign_id Kampanjan tunnistetieto.
   * @param DateString $start_time = null. Rajauksen aloitusaika.
   * @param DateString $end_time = null. Rajauksen lopetusaika.
   */

  function getContactHistoryReport($user_id, $campaign_id, $start_time = null, $end_time = null) {
    // TODO:  viesti ?? + vie ja sulje painikkeiden toiminta + ulkoasu
    $campaign = false;
    $contactinfo = false;
    $username = "";
    //Kyttjn rajoitus kyselyiss
    $kayttajarajoitus = "";
    //Aikarajoitus kyselyiss
    $aikarajoitus = "";

    $current_user = $this->Session->read('user');

    // Jos kampanjan tunniste on laiton (esim. vrn muotoinen tai eri kyttjasiakkaan), asetetaan se -1:ksi
    if (! is_numeric($campaign_id)
    || $this->CampaignsUser->findCount(array(
    'CampaignsUser.user_id' => $current_user['id'],
    'CampaignsUser.campaign_id' => $campaign_id
    )) < 1
    ) {
      $campaign_id = -1;
    }

    //Mahdollinen kyttjrajoitus
    if ($user_id <> -1){
      $user = $this->User->find(
      array('User.id' => $user_id),
      array('User.name'),
      null,
      0
      );
      $username = $user['User']['name'];
      $kayttajarajoitus = "AND Event.user_id = $user_id";
    }

    //Mahdollinen aikarajoitus
    if ($start_time !== null && $end_time === null ){
      $aikarajoitus = "AND Event.start_time >= '$start_time'";
    } else if ($start_time !== null && $end_time !== null){
      $aikarajoitus = "AND Event.start_time BETWEEN '$start_time' AND '$end_time'";
    }

    // Jos valittu jokin kampanja, haetaan sen tiedot.
    if ($campaign_id >= 0) {
      $campaign = $this->Campaign->find(
      array('Campaign.id' => $campaign_id, 'Campaign.user_client_id' => $current_user['user_client_id']),
      array('Campaign.*'),
      null,
      0
      );

      $tyhja = "''";
      $contactinfo = $this->TargetClient->query('
        SELECT TargetClient.name, TargetClient.y_id, TargetClient.domain, TargetClient.exchange_number, TargetClient.address, TargetClient.email_address, TargetClient.homepage, TargetClient.inoa_id, Event.event_type_id, Event.contact_name, Event.contact_title, Event.contact_phone_number, Event.contact_email_address, User.name
          FROM target_clients as TargetClient, events as Event, users as User
         WHERE TargetClient.campaign_id = ' . $campaign_id . '
           AND Event.target_client_id = TargetClient.id
           AND Event.id IN
              (SELECT Event.id
                FROM events as Event 
                WHERE (Event.target_client_id, Event.start_time) IN 
                      (SELECT Event.target_client_id, MAX(Event.start_time) 
                         FROM events as Event 
                        GROUP BY Event.target_client_id))
                  AND Event.target_client_id = TargetClient.id 
           ' . $kayttajarajoitus . '
           ' . $aikarajoitus . '
           AND User.id = Event.user_id
         ORDER BY TargetClient.name, Event.start_time, User.name
    ');
    }

    $this->set('limit_start_time', $start_time);
    $this->set('limit_end_time', $end_time);
    $this->set('limit_user_name', $username);
    $this->set('campaign_info', $campaign);
    $this->set('contact_info', $contactinfo);

  }

  /**
   *     Tuottaa yhteydenotto/soitto-sivun.
   *
   * @param int $user_id Kampanjaan kuuluvan kyttjn tunnistetieto. Jos arvo -1,
   * tuotetaan raportti kaikista kyttjist.
   * @param int $campaign_id Kampanjan tunnistetieto.
   * @param DateString $start_time = null. Rajauksen aloitusaika.
   * @param DateString $end_time = null. Rajauksen lopetusaika.
   */
  function getContactInfoReport($user_id, $campaign_id, $start_time = null, $end_time = null) {
    // TODO:  viesti ?? + vie ja sulje painikkeiden toiminta + ulkoasu
    $campaign = false;
    $callhistory = false;
    $username = "";
    //Kyttjn rajoitus kyselyiss
    $kayttajarajoitus = "";
    //Aikarajoitus kyselyiss
    $aikarajoitus = "";

    $current_user = $this->Session->read('user');

    // Jos kampanjan tunniste on laiton (esim. vrn muotoinen tai eri kyttjasiakkaan), asetetaan se -1:ksi
    if (! is_numeric($campaign_id)
    || $this->CampaignsUser->findCount(array(
    'CampaignsUser.user_id' => $current_user['id'],
    'CampaignsUser.campaign_id' => $campaign_id
    )) < 1
    ) {
      $campaign_id = -1;
    }

    //Mahdollinen kyttjrajoitus
    if ($user_id <> -1){
      $user = $this->User->find(
      array('User.id' => $user_id),
      array('User.name'),
      null,
      0
      );
      $username = $user['User']['name'];
      $kayttajarajoitus = "AND Event.user_id = $user_id";
    }

    //Mahdollinen aikarajoitus
    if ($start_time !== null && $end_time === null ){
      $aikarajoitus = "AND Event.start_time >= '$start_time'";
    } else if ($start_time !== null && $end_time !== null){
      $aikarajoitus = "AND Event.start_time BETWEEN '$start_time' AND '$end_time'";
    }

    // Jos valittu jokin kampanja, haetaan sen tiedot.
    if ($campaign_id >= 0) {
      $campaign = $this->Campaign->find(
      array('Campaign.id' => $campaign_id, 'Campaign.user_client_id' => $current_user['user_client_id']),
      array('Campaign.*'),
      null,
      0
      );

      $tyhja = "''";
      $callhistory = $this->TargetClient->query('
        SELECT Event.start_time, Event.end_time, TargetClient.name, User.name, Event.event_type_id, Event.contact_name, Event.contact_phone_number, Event.contact_email_address, Event.interest, Event.comment
          FROM target_clients as TargetClient, events as Event, users as User
         WHERE TargetClient.campaign_id = ' . $campaign_id . '
           AND Event.target_client_id = TargetClient.id
           AND Event.user_id = ' . $current_user['id'] . '
           ' . $kayttajarajoitus . '
           ' . $aikarajoitus . '
           AND User.id = Event.user_id
         ORDER BY TargetClient.name, Event.start_time, User.name
    ');
    }
    $this->set('limit_start_time', $start_time);
    $this->set('limit_end_time', $end_time);
    $this->set('limit_user_name', $username);
    $this->set('campaign_info', $campaign);
    $this->set('call_history', $callhistory);
    $this->set('scripts', array(
    'src/scriptaculous',
    ));
  }
  
  /**
   *  Tuottaa laskutustietosivulle yhteystiedot-taulukon.
   *
   * @param int $campaign_id Aktiivisen kampanjan tunnistetieto.
   * @param int $target_client_id Kohdeasiakkaan tunnistetieto.
   */
  function getContactInfo($campaign_id = null, $target_client_id = null) {
    $campaign = false;
    $allow_email_sending = true;
    $salesarguments = array();
    $callsleft = 0;
    $current_user = $this->Session->read('user');
    $campaigns_user_id = -1;
    $save_error = false;

    // Varmistetaan, ett meill on kelvolliset parametrit
    if (!is_numeric($campaign_id) || !is_numeric($target_client_id)
    || $campaign_id < 0 || $target_client_id <0){
      $this->flash("Parametrit virheelliset", "/campaigns/index");
      return;
    }
    // Tarkistetaanpas oikeudet thn kampanjaan

    $campaigns_user = $this->CampaignsUser->find(array(
    'CampaignsUser.user_id' => $current_user['id'],
    'CampaignsUser.campaign_id' => $campaign_id
    ));    
    if (count($campaigns_user) < 1){
      $this->flash("Ei kyttoikeutta kampanjaan", "/campaigns/index");
      return;
    }
    $campaigns_user_id = $campaigns_user['CampaignsUser']['id'];
    //Asetetaan callsleft 
	$callsleft = $campaigns_user['CampaignsUser']['calls_per_day'] - $this->CampaignsUser->getCallsDoneToday($campaign_id, $current_user['id']);
    // Jos negatiivinen, niin 0 
	$callsleft < 0 ? 0 : $callsleft; 
	// Tarkistetaan oikeudet asiakkaaseen
    if ($this->TargetClient->findCount(array(
    'TargetClient.id' => $target_client_id,
    'TargetClient.campaigns_user_id' => $campaigns_user_id
    )) < 1
    ) {
      $this->flash("Ei kyttoikeutta asiakkaaseen", "/campaigns/index");
      return;
    }


    if (!empty($this->data)){
      // Tallennusyritys      
      if (!$this->newEvent($campaigns_user_id)){

        $save_error = true;
      }

    } else {
      //Jos valittu jokin kohdeasiakas, haetaan sen tiedot.
      
      $targetclient = $this->TargetClient->find(
      array('TargetClient.id' => $target_client_id, 'TargetClient.campaigns_user_id' => $campaigns_user_id ),
      array('TargetClient.*'),
      null,
      0
      );
      // Jos ei ole aloitettu, on tila kesken
      if ($targetclient['TargetClient']['target_client_state_id'] == "Ei aloitettu"){
        $targetclient['TargetClient']['target_client_state_id'] = "Kesken";


      }
      // Tmkin haetaan vain, jos ei ole haluttu tallentaa
      $event = $this->Event->getLatestEvent($target_client_id);
      // Eventin event_type_id ei tule ruutuun
      
       
      // TODO arvojen parsiminen oikein

      if (empty($this->data)){
        $this->data = array();
      }

      $this->data['TargetClient'] = $targetclient['TargetClient'];
      $this->data['Event'] = $event['Event'];
      $this->data['Event']['event_type_id'] = "Valitse...";
      $this->data['Event']['sales_argument_id'] = 0;
      $this->data['Event']['newsalesargument'] = "";

    }
    // TODO:  viesti ?? + kokonaan kesken

    // Haetaan kampanja
    $campaign = $this->Campaign->find(
    array('Campaign.id' => $campaign_id, 'Campaign.user_client_id' => $current_user['user_client_id']),
    array('Campaign.*'),
    null,
    0
    );

    //Luokittelutiedot

    $salesarguments_temp = $this->SalesArgument->generateList(
    array('SalesArgument.campaign_id' => $campaign_id),
    null,null,"{n}.SalesArgument.id", "{n}.SalesArgument.argument"
      );
    $salesarguments[0] = "Valitse...";
    $salesarguments = array_merge($salesarguments, $salesarguments_temp);
        
    //Myyntiargumentit
    // $classifications = $this->Classification->findAll(
    //array('Classification.campaign_id' => $campaign_id), array('Classification.id', 'Classification.classification'),
    //null,0,0,0);
    $classifications = $this->Classification->query("SELECT Classification.id, Classification.classification, ClassificationsTargetClient.target_client_id
														FROM classifications as Classification 
															LEFT JOIN (SELECT target_client_id, classification_id 
																				FROM classifications_target_clients 
																					WHERE target_client_id =" . $this->data['TargetClient']['id'] . ") AS ClassificationsTargetClient 
																ON ClassificationsTargetClient.classification_id = Classification.id  
																		WHERE Classification.campaign_id =". $this->data['TargetClient']['campaign_id']);

    // Jos on ollut virheellinen tallennus, niin pitisi merkit liitokset oikein..
    if ($save_error){
      $classification_revisited = array();
      $i = 0;
      foreach ($classifications as $classification) {
        if (is_numeric($this->data['classifications'][$i]['Classification']['id'])){
          // Valittu, tee se valituksi
          $classifications[$i]['classifications_target_clients']['target_client_id'] = $this->data['TargetClient']['id'];
        } else {
          // Lisliitos
          $classifications[$i]['classifications_target_clients']['target_client_id'] = null;
        }
        $i++;
      }

    }

    //Kohdeasiakkaan myyntiargumentti ja liitokset
    $classificationstargetclients = $this->ClassificationsTargetClients->findall(
    array('ClassificationsTargetClients.target_client_id' => $target_client_id),
    array('ClassificationsTargetClients.classification_id'),
    null,
    0,0,0
    );

    //Kohdeasiakkaan tilat
    $targetclientstates = $this->TargetClientState->findall(
    array('TargetClientState.id' => '<> Ei aloitettu'),
    array('TargetClientState.id'),
    null,
    0,0,0
    );

    //Kiinnostumattomuuden syyt
    $reasonnointerests = $this->ReasonNoInterest->findall(
    null,
    array('ReasonNoInterest.id'),
    null,
    0,0,0
    );


    // calltypes pit olla toisin
    $call_types_search['EventTypesWithClass.event_type_class_id'] = 'Soitto';
    $calltypes = $this->EventTypesWithClass->findAll($call_types_search);
    $call_types_list = array();
    $call_types_list["Valitse..."] = "Valitse...";


    foreach ($calltypes as $call_type) {
      $call_types_list[$call_type['EventTypesWithClass']['event_type_id']] = $call_type['EventTypesWithClass']['event_type_id'];
    }
    // Listn thn tietojen muutos
    $call_types_list['Tietojen muutos'] = "Tietojen muutos";

    $callstoday = $this->CampaignsUser->getCallsDoneToday($current_user['id'],$campaign_id);

    //TODO allow_email_sending
    $allow_email_sending = true;
    /*
     if ($event['Event']['event_type_id'] == 'Luotu') {
     $allow_email_sending = true;
     }
     */

    $callhistory = $this->TargetClient->query('
        SELECT Event.start_time, Event.end_time, User.id, User.name, Event.event_type_id, Event.contact_name, Event.contact_phone_number, Event.contact_email_address, Event.interest, Event.comment
          FROM target_clients as TargetClient, events as Event, users as User
         WHERE TargetClient.id = ' . $target_client_id . '
           AND Event.target_client_id = TargetClient.id
           AND Event.user_id = ' . $current_user['id'] . '
           AND User.id = Event.user_id         
         ORDER BY TargetClient.name, Event.start_time DESC, User.name
    ');


    $this->set('campaign_id', $campaign_id);
    $this->set('allow_email_sending', $allow_email_sending);
    if (!isset($this->data)){
      $this->data = array();
    }
    // Asetetaan tmn hetkinen aika
    $this->data['Event']['start_time'] = time();
    $this->set('save_error', $save_error);
    $this->set('call_types', $call_types_list);
    $this->set('sales_arguments', $salesarguments);
    $this->set('classifications', $classifications);
    $this->set('target_client_states', $targetclientstates);
    $this->set('reason_no_interests', $reasonnointerests);
    $this->set('call_history', $callhistory);
    $this->set('calls_today', $callstoday);
    $this->set('calls_left', $callsleft);
    $this->set('styles', array('../js/jscalendar/calendar-win2k-1'));
    $this->set('scripts', array(
    'src/scriptaculous',
    'jscalendar/calendar',
    'jscalendar/lang/calendar-fi',
    'jscalendar/calendar-setup'
    ));      

  }

  /**
   * Suoritetaan kun soittoikkunassa on muutettu/listty tietoja ja painettu Tallenna -painiketta.
   *
   */
  private function newEvent($campaigns_user_id){
    // Tarkistetaan tuleeko meille dataa

    if (!empty($this->data)){
      $this->forStringsInArray($this->data, 'sql', $this->sanitizer);
      /** Kyttj sessiossa */
      $user = null;
      /** Kampanjan tunnus */
      $campaign_id = -1;
      /** campaigns_user_id*/
      $campaigns_user_id = -1;
      /** Uuden myyntiargumentin id */
      $sales_argument_id = null;
      /** Kampanjan tiedot */
      $campaign = null;
      /** TargetClient tiedot */
      $target_client = null;
      /** Luokittelutiedot */
      $classifications = null;
      /** Event tiedot */
      $event = null;
      /** Transaktion rollback */
      $rollback = false;

      // Aloitetaan transaktio
      $this->TargetClient->execute("BEGIN WORK");

      /**
       * TargetClient-taulun osuus
       */

      //Asetetaan Target-muuttujaan sallitut tiedot
      $target_client['TargetClient']['id'] = $this->data['TargetClient']['id'];
      $target_client['TargetClient']['name']= $this->data['TargetClient']['name'];
      $target_client['TargetClient']['y_id']= $this->data['TargetClient']['y_id'];
      $target_client['TargetClient']['email_address'] = $this->data['TargetClient']['email_address'];
      $target_client['TargetClient']['domain']= $this->data['TargetClient']['domain'];
      $target_client['TargetClient']['exchange_number'] = $this->data['TargetClient']['exchange_number'];
      $target_client['TargetClient']['address'] = $this->data['TargetClient']['address'];
      $target_client['TargetClient']['homepage'] = $this->data['TargetClient']['homepage'];
      $target_client['TargetClient']['target_client_state_id'] = $this->data['TargetClient']['target_client_state_id'];

      // Tarkistetaan onko kyttjll oikeutta tallentaa thn kampanjaan kamaa
      $user = $this->Session->read('user');

      // Haetaan target_clientiin kuuluva campaign_id
      $target_client_database = $this->TargetClient->findById($target_client['TargetClient']['id']);
      $campaign_id = $target_client_database['TargetClient']['campaign_id'];
      // Tm pit sytt takaisin nkymn
      $this->data['TargetClient']['campaign_id'] = $campaign_id;


      // Koitetaan tallentaa target_clientin tiedot

      if (!$this->TargetClient->save($target_client)){
        // Jos targetClient['name'] on tyhj, iin korvataan se alkuperisell
        if ($this->data['TargetClient']['name'] == ""){
          $this->data['TargetClient']['name'] = $target_client_database['TargetClient']['name'];
        }
        $rollback = true;
      }
      
      /*
       * TargetClientClassification-taulun osuus
       */

      // Tallennetaan target_client_classifications-tiedot
      //Poistetaan vanhat classificationit
      // Id on validi intti,koskapa save on jo aiemmin mennyt lpi
      $this->Classification->query("delete from classifications_target_clients where target_client_id =" . $target_client['TargetClient']['id']);

      //Tallennetaan uuded liitokset

      if (!empty($this->data['classifications'])){
        $classifications = $this->data['classifications'];
        foreach ($classifications as $classification) {
          if (is_numeric($classification['Classification']['id'])){
            $save_array['ClassificationsTargetClients']['classification_id'] = $classification['Classification']['id'];
            $save_array['ClassificationsTargetClients']['target_client_id'] = $target_client['TargetClient']['id'];
            if (!$this->ClassificationsTargetClients->save($save_array)){
              $rollback = true;
              $this->Classification->invalidate('id');
            }
          }
        }
      }

      /**
       * Event-taulun osuus
       */

      // Varmistetaan, ett eventin tiedoissa ei ole mitn laitonta

      $event = $this->data;
      unset($event['TargetClient']);
      unset($event['classifications']);
      unset($event['redirect_path']);
      $event['Event']['id'] = null;


      // Ajan tarkistaminen
      // Trimmataan aika
      $event['Event']['contact_at'] = trim($event['Event']['contact_at']);
      
      
      if ($event['Event']['contact_at'] <> ""){      
      if ( (preg_match(VALID_DATETIME, $event['Event']['contact_at']))) {
        // Aika db-muotoon
        $event['Event']['contact_at'] = $this->Event->timeToDbDateTime($event['Event']['contact_at']);
        // Varmistetaan, ett tm ei ole menneisyydess
        if ($event['Event']['contact_at'] === false
            || $event['Event']['contact_at'] < date(Event::DB_DATE_FORMAT . ' ' . Event::DB_TIME_FORMAT, time())){
          $this->Event->invalidate('contact_at');
          // Palautetaan structiin alkuperinen
          $event['Event']['contact_at'] = $this->data['Event']['contact_at'];
        }
      } else {
        
        $this->Event->invalidate('contact_at');
      }
      } else {
        $event['Event']['contact_at'] = null;
      }
      // Asetetaan kyttjn id oikeaksi
      $event['Event']['user_id'] = $user['id'];
      // Samoin target_client_id
      $event['Event']['target_client_id'] = $target_client['TargetClient']['id'];
      //TODO kyttjn antama muutostieto

      /*
       * Myyntiargumentit
       */
      // Jos meill on tss 0, niin silloin sit ei ole valittu
      if ($event['Event']['sales_argument_id'] == 0){
          $event['Event']['sales_argument_id'] = null;
      }
      // Listn uusi myyntiargumentti, jos tarpeen
      if (!empty($event['Event']['newsalesargument'])){
        $sales_argument_search['SalesArgument.campaign_id'] = $campaign_id;
        $sales_argument_t = $this->SalesArgument->findByArgument($event['Event']['newsalesargument']);

        if (!empty($sales_argument_t)){
          $this->SalesArgument->invalidate('argument');
          $rollback = true;
        } else {
          $sales_argument_save['SalesArgument']['argument'] = $event['Event']['newsalesargument'];
          $sales_argument_save['SalesArgument']['campaign_id'] = $campaign_id;
          if (!$this->SalesArgument->save($sales_argument_save)){
            $rollback = true;
            $this->SalesArgument->invalidate('argument');
          } else {
            $sales_argument_id = $this->SalesArgument->getLastInsertId();
            // Asetetaan se structiin
            $event['Event']['sales_argument_id'] = $sales_argument_id;
          }
        }
        $this->data['Event']['newsalesargument'] = $event['Event']['newsalesargument'];
        $this->data['Event']['event_type_id'] = "Valitse...";
      }

      //Start time?
      //Laitetaan end_time kohdalleen
      
      $end_time = time();
      // Mahdollinen kyttjkorjaus
      if (is_numeric($event['Event']['duration']) && ($end_time - $event['Event']['start_time']) > is_numeric($event['Event']['duration'])){
          $event['Event']['start_time'] = $event['Event']['duration'];
      }
      $event['Event']['start_time'] = date("Y-m-d H:i:s", $event['Event']['start_time']);
      $event['Event']['end_time'] = date("Y-m-d H:i:s", time());
      if ($event['Event']['start_time']> $event['Event']['end_time']){
        $this->TargetClient->execute("ROLLBACK");
        //VAKAVA VIRHE
	    $this->flash("Lomakeparametreissa virheellist tietoa", "/campaigns/index");
	    die();
      }

      /*
       unset$event['Event']['start_time']);
       unset($event['Event']['end_time']);
       */

      // Event-typen tarkistus
      // TODO vain soittokelpoiset

      $event_type = $this->EventTypesWithClass->findByEvent_type_id($event['Event']['event_type_id']);
      if (empty($event_type)){
        $this->Event->invalidate('event_type_id');
        $rollback = true;
      }

      // SalesArgumentin tarkistus
      if ($event['Event']['sales_argument_id'] <> null){
        $sales_argument = $this->SalesArgument->findById($event['Event']['sales_argument_id']);
        if (empty($sales_argument)){
          $this->SalesArgument->invalidate('argument');
          $rollback = true;
        }
      }

      // Kiinnostuksen tarkistus
      if (!is_numeric($event['Event']['interest']) ||$event['Event']['interest']< 0 || $event['Event']['interest']> 100){
        $this->Event->invalidate('interest');
        $rollback = true;
      }


      // Koitetaan tallentaa
      if (!$this->Event->validates($event)){
        // Jos nimi on tyhj, niin se pit palauttaa alkuperiseksi
        $event_from_database = $this->Event->getLatestEvent($target_client['TargetClient']['id']);
        $this->data['Event']['contact_name'] = $event_from_database['Event']['contact_name'];
      }
       
      if (!$rollback){

        if (!$this->Event->save($event)){
          $rollback = true;
        }
      }

      /*
       * Lopputoimenpiteet
       */
       
      // Uudelleenohjaus
      if ($rollback){
        $this->TargetClient->execute("ROLLBACK");
        return false;
      } else {
        $this->TargetClient->execute("COMMIT");

        $this->redirect($this->data['redirect_path']);
      }
    }
  }

  /**
   *  Tuottaa laskutustietosivulle kommentit-taulukon.
   *
   * @param int $user_id Kampanjaan kuuluvan kyttjn tunnistetieto. Jos arvo -1,
   * tuotetaan raportti kaikista kyttjist.
   * @param int $campaign_id Kampanjan tunnistetieto.
   * @param DateString $start_time = null. Rajauksen aloitusaika.
   * @param DateString $end_time = null. Rajauksen lopetusaika.
   */
  function getCommentReport($user_id, $campaign_id, $start_time = null, $end_time = null) {
    // TODO:  viesti ?? + vie ja sulje painikkeiden toiminta  + ulkoasu
    $campaign = false;
    $comments = false;
    $username = "";
    //Kyttjn rajoitus kyselyiss
    $kayttajarajoitus = "";
    //Aikarajoitus kyselyiss
    $aikarajoitus = "";

    $current_user = $this->Session->read('user');

    // Jos kampanjan tunniste on laiton (esim. vrn muotoinen tai eri kyttjasiakkaan), asetetaan se -1:ksi
    if (! is_numeric($campaign_id)
    || $this->CampaignsUser->findCount(array(
    'CampaignsUser.user_id' => $current_user['id'],
    'CampaignsUser.campaign_id' => $campaign_id
    )) < 1
    ) {
      $campaign_id = -1;
    }

    //Mahdollinen kyttjrajoitus
    if ($user_id <> -1){
      $user = $this->User->find(
      array('User.id' => $user_id),
      array('User.name'),
      null,
      0
      );
      $username = $user['User']['name'];
      $kayttajarajoitus = "AND Event.user_id = $user_id";
    }

    //Mahdollinen aikarajoitus
    if ($start_time !== null && $end_time === null ){
      $aikarajoitus = "AND Event.start_time >= '$start_time'";
    } else if ($start_time !== null && $end_time !== null){
      $aikarajoitus = "AND Event.start_time BETWEEN '$start_time' AND '$end_time'";
    }

    // Jos valittu jokin kampanja, haetaan sen tiedot.
    if ($campaign_id >= 0) {
      $campaign = $this->Campaign->find(
      array('Campaign.id' => $campaign_id, 'Campaign.user_client_id' => $current_user['user_client_id']),
      array('Campaign.*'),
      null,
      0
      );

      $tyhja = "''";
      $comments = $this->TargetClient->query('
        SELECT Event.start_time, Event.comment, TargetClient.name, User.name
          FROM target_clients as TargetClient, events as Event, users as User
         WHERE TargetClient.campaign_id = ' . $campaign_id . '
           AND Event.target_client_id = TargetClient.id
           AND Event.user_id = ' . $current_user['id'] . '
           ' . $kayttajarajoitus . '
           ' . $aikarajoitus . '
           AND Event.comment > ' . $tyhja . '
           AND User.id = Event.user_id
         ORDER BY TargetClient.name, Event.start_time, User.name
    ');
    }
    $this->set('limit_start_time', $start_time);
    $this->set('limit_end_time', $end_time);
    $this->set('limit_user_name', $username);
    $this->set('campaign_info', $campaign);
    $this->set('comments', $comments);
  }


}
?>