<?php
/**
 *EventMessageLinksController 
 * @author Ohjelmistotuotantoprojektiryhm myva, Helsingin yliopisto, Tietojenksittelytieteenlaitos
 * @version
 * @package myva
 * @subpackage Controllers
 */
class EventsMessageLinksController extends AppController {

	var $name = 'EventsMessageLinks';
  var $uses = array('EventsMessageLink', 'LatestEvent');
	

	/**
	 * Luokan alustusfunktio. Asettaa metodit, joiden yhteydess nytetn valikot, tai jotka vaativat yllpitjn kyttoikeudet.
	 */
	function __construct (){
    parent::__construct();
    $this->need_not_login = array('event', 'test');
    $this->need_not_menus = array('event', 'test');
  }
  
  /**
   * Ottaa vastaan viestiss olevan majakkakutsun sek viestin linkin klikkauksen ja
   * tekee uudelleenohjauksen kutsun tunnistetta vastaavaan osoitteeseen.
   * 
   * @param string id Tunniste, joka vastaa tietokannan taulun events_message_links kentn id arvoa.
   *         Tunnisteen perusteella tunnistetaan pyyntn liittyvt tapahtumat ja linkit.
   */
  function event($id = null) {    
    if ($id !== null && preg_match(VALID_SHA1, $id)) {
      $redirect_url = $this->EventsMessageLink->messageEvent($id);
      if ($redirect_url !== false) {
        $this->redirect($redirect_url);
        return;
      }
    }

    // Jos ei epkelpo id
    header("HTTP/1.0 404 Not Found");
    exit();
  }
}
?>
