<?php
/**
 * Tm luokka tekee sit sun tt...
 * @author Ohjelmistotuotantoprojektiryhm myva, Helsingin yliopisto, Tietojenksittelytieteenlaitos
 * @version luuranko-versio 0.0.1
 * @package myva
 * @subpackage Controllers
 */
class UsersController extends AppController {

  var $name = 'Users';
  var $uses = array('User', 'CampaignsUser');
  var $helpers = array('html', 'javascript');
  

  /**
   * Luokan alustusfunktio. Asettaa metodit, joiden yhteydess nytetn valikot, tai jotka vaativat yllpitjn kyttoikeudet.
   */
  function __construct (){
    parent::__construct();
    $this->need_not_login = array('index','login');
  }

  /**
   * Selityst index()-funktiosta
   *
   */
  function index(){
    $this->set('styles', array('campaigns/index')); 
    $this->set('scripts', array());
  }

  /**
   * Tarkistaa kyttjtunnuksen ja salasanan. Jos salasana tai kyttjtunnus
   * on vrin, renderidn user/index.thtml ja asetetaan virhemuuttuja
   * trueksi. Onnistuneen kirjauksen jlkeen asetetaan sessiomuuttuja oikein ja
   * redirectoidaan Campaign/index.
   *
   * @param postarray $dataLomakkeen tiedot.
   * <ul>
   *   <li>['User']['username'] string Kyttjtunnus. Kontrolleri muuntaa suuret kirjaimet pieniksi ennen jatkoksittely. </li>
   *   <li>['User']['password'] string Salasana.</li>
   * </ul>
   */
  function login(){
    /** Salasana hashattuna */
    $password_hash = "";
    /** Kyttjn tiedot */
    $user = "";
    /** Hakuarray */
    $search_array = "";

    //Tutkitaan onko meill tulossa post-formia
    if (empty($this->data)){
      // Ei formia, heitetn tyynesti etusivulle
      $this->redirect('Users/index');

    } else {
      // Muutetaan salasan hashiksi
      $password_hash = sha1($this->data['User']['password']);
      // Luodaan hakuehdot
      $search_array = array("User.username" => $this->data['User']['username'],
      "User.password" => $password_hash,
      "User.active_account" => true);
      // Haetaan
      $user = $this->User->find($search_array,'',null, 0);
      // Jos tyhj
      if (empty($user)){
        // pistetn virheilmoitus nkymn
        $this->User->invalidate('username');
        // Kaivetaanpas joku kampanja thn        
        // renderidn nkym
        $this->set('styles', array('campaigns/index'));
        $this->set('scripts', array());
        $this->render('index');
      } else {
        //TODO tlt ohjataan sitten velhon etusivulle, kunhan eka on sessio asetettu oikein
        // Asetetaan sessiomuuttujia oikein
        $user_to_sessio = $user['User'];
        
        // Tallennetaan kyttjn tiedot
        $this->Session->write('user', $user_to_sessio);
        // Tallennetaan aika
        $this->Session->write('last_user_event_time', time());
        $this->set('user', $this->Session->read('user'));
        $user = $this->Session->read('user');
        $search_array = array("CampaignsUser.user_id"=> $user['id']);
        $search_array[0] = "Campaign.start_time <= date(now()) and (Campaign.end_time >= date(now()) or Campaign.end_time is null)";
        $campaign = $this->CampaignsUser->find($search_array, null, "Campaign.start_time DESC");
                
        $this->Redirect('/campaigns/index/' . $campaign['Campaign']['id']);
      }

    }

  }
  /**
   * Uloskirjautuminen
   */
  function logout(){
    $this->Session->delete('user');
    $this->flash("Uloskirjauduttu", "/users/");
    exit();
  }
  
   
  /**
   * Salasanan vaihtaminen
   * Ajax-toteutus, ei kutsuta suoraan
   */
  
  function changePassword(){
    $user =$this->Session->read('user');
    $this->set('user_id', $user['id']);
    if (!empty($this->data)){      
      // Tehdn hakuarray
      $search_array = array("User.id" => $this->data['User']['id'],
      "User.password" => sha1($this->data['User']['password']));
      // 1. lytyyk 2. tsmk vanhat
      if ($this->User->find($search_array) && $this->data['User']['new_password'] == $this->data['User']['new_password2']){
        // luodaan hashi
        $this->data['User']['password'] = sha1($this->data['User']['new_password']);
        // jos tallentuu, niin
        //TODO lopullinen toteutus sitten tnne
        if ($this->User->save($this->data)){
          $this->set('onnistui', 1);
        }

      } else {

        $user = $this->Session->read('user');
        $this->set('user_id', $user['id']);
        $this->set('debug', $this->data);
        $this->User->invalidate('id');
        // Tm tekee virheen
        $this->set('onnistui', 0);
      }

      
    }
    $this->render('ajaxChangePasswd', 'ajax');
  }

}
