<?php
/**
 * MYVA global constants.
 * Thn tiedostoon tulevat vakiot, joita ei ole tarkoitettu jrjestelmn yllpitjn asetettavaksi.
 * 
 * @author Ohjelmistotuotantoprojektiryhm myva, Helsingin yliopisto, Tietojenksittelytieteenlaitos
 * @version
 * @package myva
 * @subpackage Definitions
 */
class MYVA_CONST {

/**
 * Merkkimr joka otetaan yrityksen nimest mukaan parsimisten jlkeen kun etsitn lhiosumia
 */
  const COMPANY_NAME_MAX_SIZE = 4;

/**
 * Kuinka pitkn ajan (sekunteissa) perusteella nykyhetkest erntyv yhteydenotto luokitellaan 1 prioriteetin tapahtumaksi soittoa valittaessa
 */
  const TIME_FROM_PRESENT_TIME = 300;

  /**
   * Kuinka monta kertaa yritetn toimintoa virhetilanteessa uudelleen.
   * Arvon oltava >= 0
   */
  const MAX_RETRIES = 10;

  /**
   * Jrjestelmn sivujen valikon osat.
   * Jos pass sislt jotain, ensimmisen alkion oltava tyhj merkkijono.
   * 
   * Kyttesimerkki nkymss:
   * 
   * <?php
   *   echo $html->link(MYVA_CONST::$MENU_PAGES['unfinished']['name'],
   *     MYVA_CONST::$MENU_PAGES['unfinished']['controller']
   *       . '/' . MYVA_CONST::$MENU_PAGES['unfinished']['action']
   *       . '/' . $campaign_id
   *       . implode('/', MYVA_CONST::$MENU_PAGES['unfinished']['pass']);
   * ?>
   */
  static $MENU_PAGES = array(
    'unfinished' => array(
      'name' => 'Ksittelemttmt',
      'controller' => 'campaignsUsers',
      'action' => 'showCampaignTargets',
      'pass' => array('', 'unfinished'),
      'require_selected_campaign' => true,
      'require_user_in_campaign' => true,
      'require_campaign_admin' => false
    ),
    'finished' => array(
      'name' => 'Ksitellyt',
      'controller' => 'campaignsUsers',
      'action' => 'showCampaignTargets',
      'pass' => array('', 'finished'),
      'require_selected_campaign' => true,
      'require_user_in_campaign' => true,
      'require_campaign_admin' => false
    ),
    'call' => array(
      'name' => 'Soitto',
      'controller' => 'events',
      'action' => 'chooseNextCall',
      'pass' => array(),
      'require_selected_campaign' => true,
      'require_user_in_campaign' => true,
      'require_campaign_admin' => false
    ),
    'user_reports' => array(
      'name' => 'Raportit', 
      'controller' => 'campaigns',
      'action' => 'userCampaignReport',
      'pass' => array(),
      'require_selected_campaign' => true,
      'require_user_in_campaign' => true,
      'require_campaign_admin' => false
    ),
    'campaign_reports' => array(
      'name' => 'Yllpitjn raportit', 
      'controller' => 'campaigns',
      'action' => 'campaignReport',
      'pass' => array(),
      'require_selected_campaign' => true,
      'require_user_in_campaign' => false,
      'require_campaign_admin' => true
    ),
    'campaign_management' => array(
      'name' => 'Kampanja', 
      'controller' => 'campaigns',
      'action' => 'campaignManagement',
      'pass' => array(),
      'require_selected_campaign' => false,
      'require_user_in_campaign' => false,
      'require_campaign_admin' => true
    )
  );

/**
 * Desimaalien mr raporttien numerotiedoissa
 */
  const REPORT_ROUND_DECIMALS = 1;
  
/**
 * Merkist, jolla jrjestelm lhett tiedot
 */
  const ENCODING = 'iso-8859-1';
}
?>
