<?php
/**
 * LatestEvent
 * @author Ohjelmistotuotantoprojektiryhm myva, Helsingin yliopisto, Tietojenksittelytieteenlaitos
 * @version
 * @package myva
 * @subpackage Models
 */
class LatestEvent extends AppModel {

  var $name = 'LatestEvent';

  var $belongsTo = array('User' =>
  array('className'  => 'User'
                           ),
  'SalesArgument' =>
  array('className'  => 'SalesArgument'
                           ),
  'TargetClient' =>
  array('className'  => 'TargetClient'
                           ),
  'EventType' =>
  array('className'  => 'EventType'
                           ),
  'ReasonNoInterest' =>
  array('className'  => 'ReasonNoInterest'
                           )
  );

  /**
   * Palauttaa kohdeasiakkaaseen liittyvn viimeisimmn tapahtuman tiedot.
   *
   * @param int $target_client_id Kohdeasiakkaan tunnistetieto. Virheellisen syteparametrin tai kannasta 
   * puuttuvan tunnistetiedon tapauksessa palauttaa false.
   * 
   * @return array Viimeisimmn tapahtuman tiedot.
   * <ul>
   *   <li>[Event][id] int Tapahtuman tunnistetieto.</li>
   *   <li>[Event][start_time] DateString Tapahtuman aloitusaika.</li>
   *   <li>[Event][end_time] DateString Tapahtuman lopetusaika.</li>
   *   <li>[Event][contact_at] DateString Seuraavan yhteydenoton ajankohta. Arvo on null, jos ei ole asetettu.</li>
   *   <li>[Event][interest] int Kiinnostus.</li>
   *   <li>[Event][comment] string Kommentti.</li>
   *   <li>[Event][contact_name] string Yhteyshenkiln nimi.</li>
   *   <li>[Event][contact_title] string Yhteyshenkiln titteli.</li>
   *   <li>[Event][contact_phone_number] string Yhteyshenkiln puhelinnumero.</li>
   *   <li>[Event][contact_email_address] string Yhteyshenkiln shkpostiosoite.</li>
   *   <li>[Event][created] DateString Luontipiv.</li>
   *   <li>[Event][modified] DateString Viimeinen muutospiv.</li>
   *   <li>[Event][event_type_id] string Tapahtumatyypin nimi.</li>
   *   <li>[Event][target_client_id] int Kohdeasiakkaan tunnistetieto.</li>
   *   <li>[Event][user_id] int Kyttjn tunnistetieto.</li>
   *   <li>[Event][sales_argument_id] int Myyntiargumentien tunnistetieto.</li>
   *   <li>[Event][reason_not_interest_id] string Kiinnostumattomuuden syy.</li>
   * </ul>
   */
  function getLatestEvent($target_client_id){
    return $this->find(array("target_client_id" => $target_client_id));
  }
  
}
?>