<?php
/**
 * MessageLink
 * @author Ohjelmistotuotantoprojektiryhm myva, Helsingin yliopisto, Tietojenksittelytieteenlaitos
 * @version
 * @package myva
 * @subpackage Models
 */
class MessageLink extends AppModel {

  var $name = 'MessageLink';

  var $validate = array(
      'id' => VALID_NON_NEG_INT,
      'target_url' => VALID_URL_OR_EMPTY,
//      'target_url_text' => VALID_,
      'beacon' => VALID_BOOLEAN,
      'created' => VALID_DB_DATETIME_OR_EMPTY,
      'modified' => VALID_DB_DATETIME_OR_EMPTY,
      'campaign_id' => VALID_NON_NEG_INT
  );


  var $hasAndBelongsToMany = array('Event' =>
  array('className'    => 'Event',
  'joinTable'    => '',
  'foreignKey'   => '',
  'associationForeignKey'=> '',
  'conditions'   => '',
  'order'        => '',
  'limit'        => '',
  'unique'       => '',
  'finderQuery'  => '',
  'deleteQuery'  => '',
  )
  );

  var $belongsTo = array('Campaign' =>
  array('className'    => 'Campaign',
  'conditions'   => '',
  'order'        => '',
  'dependent'    => '',
  'foreignKey'   => ''
                        )
  );
   
  /**
   * Parsii viestist siin olevat linkit ja tallentaa ne kantaan.
   * Samalla poistetaan tietokannasta ne linkit, joita ei ole kytetty (ts. lhetetty viestiss).
   * Huom! Metodia on kutsuttava transaktion sisll!
   *
   * @param string $message Kampanjan viesti.
   * @param int $campaign_id Kampanjan tunnistetieto.
   * 
   * @return boolean Onnistuiko parsiminen.
   */
  function parseMessage($message, $campaign_id){
    // l ikin kirjoita koodia, jonka joku toinen on tehnyt sinua ennen
    # Original PHP code by Chirp Internet: www.chirp.com.au
    # Please acknowledge use of this code by including this header.    
    $regexp = "<a\s[^>]*href=(\"??)([^\" >]*?)\\1[^>]*>(.*)<\/a>";
    
    //Tarkistetaanpas onkos meill validi kampanja kytss
    $query = $this->query("select count(id) as lkm from campaigns where id = $campaign_id");
	  if ($query[0][0]['lkm'] != 1){
//    if (! $this->Campaign->hasAny(array('Campaign.id' => $campaign_id))) {
	    return false;
    }
    
    // Eka pitisi luoda majakka
    $save_array = array();
    $save_array['MessageLink']['campaign_id'] = $campaign_id;    
    $save_array['MessageLink']['id'] = null;
    
    // haetaan ksipelill
    $query = $this->query("select count(*) as lkm from message_links where campaign_id = $campaign_id and beacon = 1", false);
    
    if ($query[0][0]['lkm'] == 0){
//    if (! $this->hasAny(array('MessageLink.campaign_id' => $campaign_id, 'MessageLink.beacon' => 1))) {
      $save_array['MessageLink']['beacon'] = 1;
      if (! $this->save($save_array)) {
        return false;
      }
    } 
    
    $this->execute('
      DELETE
        FROM message_links
        WHERE campaign_id = ' . $campaign_id . '
          AND beacon = 0
          AND id NOT IN (
            SELECT message_link_id
              FROM events_message_links
          )
    ');
     
    $matches = array();
    if(preg_match_all("/$regexp/siU", $message, $matches, PREG_SET_ORDER)) { 
      foreach ($matches as $match) {
      	$save_array['MessageLink']['beacon'] = 0;
        
      	$save_array['MessageLink']['target_url'] = $match[2];
      	$save_array['MessageLink']['target_url_text'] = $match[3];
      	$save_array['MessageLink']['campaign_id'] = $campaign_id;
/*
      	$search_array = array();
      	$search_array['MessageLink.target_url'] = $match[2];
      	$search_array['MessageLink.target_url_text'] = $match[3];
      	$search_array['MessageLink.campaign_id'] = $campaign_id;
*/
      	// Jos tt ei ole viel aiemmin tallennettu, niin listnps
      	$query = $this->query("select count(*) as lkm from message_links where campaign_id = $campaign_id and beacon = 0 and target_url = '$match[2]' and target_url_text = '$match[3]'", false);
      	
        if ($query[0][0]['lkm'] == 0){
//        if (! $this->hasAny(array(
//            'MessageLink.campaign_id' => $campaign_id,
//            'MessageLink.beacon' => 0,
//            'MessageLink.target_url' => $match[2],
//            'MessageLink.target_url_text' => $match[3]
//          ))) {
         	  if (! $this->save($save_array)) {
         	    return false;
         	  }
      	}
      }      
    }
    return true;
    
  }
}
  ?>