<?php
/**
 * TargetClient
 * @author Ohjelmistotuotantoprojektiryhm myva, Helsingin yliopisto, Tietojenksittelytieteenlaitos
 * @version
 * @package myva
 * @subpackage Models
 */
class TargetClient extends AppModel {
  
  
  
  var $name = 'TargetClient';
  //TODO valid_email or empty
  var $validate = array('email_address' => VALID_EMAIL_OR_EMPTY, 
                        'name' => VALID_NOT_EMPTY, 
                         'y_id' =>VALID_YID_OR_EMPTY,
                         'exchange_number' => VALID_PHONE_NUMBER_OR_EMPTY,
                         'homepage' => VALID_URL_OR_EMPTY);

  var $belongsTo = array('TargetClientState' =>
  array('className'  => 'TargetClientState',
  'conditions' => '',
  'order'      => '',
  'foreignKey' => ''
                           ),
  'Campaign' =>
  array('className'  => 'Campaign',
  'conditions' => '',
  'order'      => '',
  'foreignKey' => ''
                           ),
  'CampaignsUser' =>
  array('className'  => 'CampaignsUser',
   
  )
  );



  var $hasMany = array('Event' =>
  array('className'     => 'Event',
  'conditions'    => '',
  'order'         => '',
  'limit'         => '',
  'foreignKey'    => '',
  'dependent'     => '',
  'exclusive'     => '',
  'finderQuery'   => ''
                         )
  );

  var $hasAndBelongsToMany = array('Classification' =>
  array('className'    => 'Classification',
  'joinTable'    => '',
  'foreignKey'   => '',
  'associationForeignKey'=> '',
  'conditions'   => '',
  'order'        => '',
  'limit'        => '',
  'unique'       => '',
  'finderQuery'  => '',
  'deleteQuery'  => '',
  )
  );

  /**
   * Raportti kohdeasiakkaiden tiloista.
   *
   * @param int $campaign_id Kampanjan tunnistetieto.
   * @param int $user_id Kyttj tunnistetieto. Kuuluttava kampanjaan. Arvo -1 palauttaa kaikkien 
   * kyttjien tiedot.
   * 
   * @return array Kohdeasiakkaan tila -taulukko.
   * <ul>
   *   <li>[0..n][TargetClient][target_client_state_id] string Kohdeasiakkaan tila.</li>
   *   <li>[0..n][TargetClient][count] int Tapahtumatyypin lukumr.</li>
   *   <li>[0..n][TargetClient][percentage_all] int Prosenttia kaikista.</li>
   *   <li>[0..n][TargetClient][percentage_started] int Prosenttia aloitetuista.</li>
   * </ul>
   */
  function getTargetClientStatesReport($user_id, $campaign_id){
    //Mahdollinen kyttjrajaus
    
    $kayttajarajoitus = "";
    //Kaikkien asiakkaiden lukumr
    $kaikkiasiakkaat = 0;
    //Hakuarray
    $hakuarray = null;
	
    //Mahdollinen kyttjrajoitus
    if ($user_id <> -1){
      $campaigns_user_id = $this->getCampaignsUserId($user_id,$campaign_id);
      $kayttajarajoitus = "AND target_clients.campaigns_user_id = $campaigns_user_id";
      $hakuarray['TargetClient.campaigns_user_id'] = $campaigns_user_id;
    }

    $hakuarray['TargetClient.campaign_id'] = $campaign_id;

    $tulos = $this->query("SELECT target_client_states.id, SUM(alakysely.lkm) AS lkm FROM target_client_states
						LEFT JOIN (SELECT target_client_state_id, COUNT(target_client_state_id) AS lkm
								FROM target_clients  
								WHERE target_clients.campaign_id = $campaign_id 
                                                             $kayttajarajoitus 
									GROUP BY target_client_state_id) AS alakysely on alakysely.target_client_state_id = target_client_states.id 
						GROUP BY target_client_states.id
                                         ORDER BY target_client_states.order");
    $palautus = "";

    //Lasketaan kaikkien asiakkaiden lukumr
    $kaikkiasiakkaat = $this->findCount($hakuarray);
    //Lasketaan soitetut
    //Haetaanpas rajoitukset

    $rivit = $this->query("SELECT event_types.id from event_types INNER JOIN event_type_classes_event_types ON event_types.id = event_type_classes_event_types.event_type_id INNER JOIN event_type_classes ON event_type_classes.id = event_type_classes_event_types.event_type_class_id where event_type_classes.id in ('Soitto')");

    /*
     $ensimminen = 0;
     $hakuarraynlisarajoite = "";
     foreach ($rivit as $rivi) {
     if ($ensimminen <> 0){
     $hakuarraynlisarajoite = $hakuarraynlisarajoite . ",";
     }
     $hakuarraynlisarajoite = $hakuarraynlisarajoite . "\"" . $rivi['event_types']['id'] . "\"";
     $ensimminen++;
     }
     $soitettutulos = $this->query("select count(distinct target_client_id) from events where event_type_id in ($hakuarraynlisarajoite)");
     $soitettujaasiakkaita = $soitettutulos[0][0]['count(distinct target_client_id)'];
     */
    $hakuarray['TargetClient.target_client_state_id'] = "<> Ei aloitettu";
    $muitakuinaloitettuja = $this->findCount($hakuarray);
    //TODO raportin muodossa vhn pohdittavaa
    foreach ($tulos as $tulosrivi) {
      $palaute['TargetClient']['target_client_state_id'] = $tulosrivi['target_client_states']['id'];
      if ($tulosrivi[0]['lkm'] == null){
     	  $palaute['TargetClient']['count'] = 0;
      } else {
         $palaute['TargetClient']['count'] = $tulosrivi[0]['lkm'];
      }
      if ($kaikkiasiakkaat == 0){
        $palaute['TargetClient']['percentage_all'] = 0;
      } else {
         $palaute['TargetClient']['percentage_all'] = ($tulosrivi[0]['lkm'] / $kaikkiasiakkaat) * 100; 
       }
      
      if ($muitakuinaloitettuja > 0){
        $palaute['TargetClient']['percentage_started'] = ($tulosrivi[0]['lkm'] / $muitakuinaloitettuja) * 100;
      } else {
        $palaute['TargetClient']['percentage_started'] = 0;
      }

      $palautus[] = $palaute;
    }


    return $palautus;


  }

  /**
   * Palauttaa tavoite saavutettu -tavoitteeseen tarvittavien kohdeasiakkaiden mrn.
   * 
   * @param int $user_id Kyttjn tunnistetieto. Kuuluttava kampanjaan. -1 palauttaa kaikkien 
   * kyttjien tiedot.
   * @param int $campaign_id Kampanjan tunnistetieto.
   * 
   * @return int lukumr, jos retn , niin palauttaa -1, false jos parametrit virheellisi tai ei liitosta
   */
  function getTargetClientsNeeded($user_id, $campaign_id){
    // Virheelliset sytteet
    if (!is_numeric($user_id) || !is_numeric($campaign_id) || $campaign_id <0){
      return false;
    }
    
    /** Hakuarray */
    $search_array = "";
    /** Tavoite saavuttujen tavoitelukumr */
	 $tavoitesaavutettutavoitelkm = 0;
	/** Tavoite saavutettujen lkm */
    $tavoitesaavutettu =  0;
    /** Asiakkaiden kokonaislukumr */
    $asiakkaidenlkm = 0;
    
    
    //Haetaan tavoite saavutettujen tavoitelukumr
	if ($user_id <> -1){
      $kyselyn_tulos = $this->query("select accomplished_amount from campaigns_users where user_id = $user_id and campaign_id = $campaign_id");
      $search_array['TargetClient.campaigns_user_id'] = $this->getCampaignsUserId($user_id, $campaign_id);
      // Jos tulee null -> false 
	  if ($search_array['TargetClient.campaigns_user_id'] == null){
	     return false;
	  }
      $tavoitesaavutettutavoitelkm = $kyselyn_tulos[0]['campaigns_users']['accomplished_amount'];
	} else {
	  $kyselyn_tulos = $this->query("select sum(accomplished_amount) as accomplished_amount from campaigns_users where campaign_id = $campaign_id");
	  $tavoitesaavutettutavoitelkm = $kyselyn_tulos[0][0]['accomplished_amount'];
	}
    
    
    //Lasketaan paljonko on kokonaisuudessaan asiakkaita;
    $search_array['TargetClient.campaign_id'] = $campaign_id;
    $asiakkaidenlkm = $this->findCount($search_array);
    
    //lasketaan paljonko on saavutettu
	$search_array['TargetClient.target_client_state_id'] = "Tavoite saavutettu";
    $tavoitesaavutettu = $this->findCount($search_array);
	
    //Lasketaan paljonko on jljell 
	$search_array['TargetClient.target_client_state_id'] = array("Kesken", "Ei aloitettu");
    $jaljella = $this->findCount($search_array);
	
    	
    $tavoiteeisaavutettu = $asiakkaidenlkm - $jaljella - $tavoitesaavutettu;	
	
    if (($tavoitesaavutettu + $tavoiteeisaavutettu) == 0){
	  return -1;
	}
	//Lasketaan suhdeluku
	$suhdeluku = $tavoitesaavutettu / ($tavoitesaavutettu + $tavoiteeisaavutettu);
	
	$vielasaadaan = $suhdeluku * ($asiakkaidenlkm - $tavoitesaavutettu - $tavoiteeisaavutettu);    
	$puuttuu = $tavoitesaavutettutavoitelkm - $tavoitesaavutettu - $vielasaadaan;
    
	//Jos suhdeluku on 
	if ($suhdeluku == 0){
	  return -1;
	}
	$tarvitaan = $puuttuu / $suhdeluku;
    	
	if ($tarvitaan < 0){
	  return 0;
	} else {
	  return round($tarvitaan);  
	}	
  }

 
}
?>