<?php
/**
 * CampaignUser-luokan testit
 *
 */
class CampaignsUserTest extends UnitTestCase {
  var $controller;
  function __construct(&$controller){
    parent::__construct();
    $this->controller = &$controller;
    $this->UnitTestCase();

    //print_r();
  }
  /**
   * getTargetClientsCountin testit
   *
   */
  function testgetTargetClientsCount(){
    // 19, kappaletta pitisi tulla yhteens
    $this->assertEqual(19, $this->controller->CampaignsUser->getTargetClientsCount(1,1,-1));
    // Yhtn ei ole valmista
	$this->assertEqual(0, $this->controller->CampaignsUser->getTargetClientsCount(1,1,1));
	// Kesken pitisi olla aika paljon
	$this->assertEqual(19, $this->controller->CampaignsUser->getTargetClientsCount(1,1,0, "Kesken kaikki"));
    //Jos kyttjll ei ole kampanjaa, niin tulee 0
	$this->assertEqual(0, $this->controller->CampaignsUser->getTargetClientsCount(1,78,-1));
	//Jos kyttj ei ole, niin tulee 0
	$this->assertEqual(0, $this->controller->CampaignsUser->getTargetClientsCount(-1,78,-1));
  }
  
  function testgetCallsPerDay(){
    //Tm yhdistelm tuottaa sata
    $this->assertEqual(100, $this->controller->CampaignsUser->getCallsPerDay(1,1));
    // Tm taas 10
    $this->assertEqual(10, $this->controller->CampaignsUser->getCallsPerDay(4,10));
    // Pitisi tulla null
    $this->assertNull($this->controller->CampaignsUser->getCallsPerDay(-1,10));
    // Samoin
    $this->assertNull($this->controller->CampaignsUser->getCallsPerDay(1,-1));
  }
  
  function testgetCallsDoneToday(){
	//Listn tlle pivlle tapahtuma
	
	$time = date("Y-m-d H:m:s", time());
	
	$this->controller->CampaignsUser->execute("INSERT INTO events (event_type_id, start_time, end_time, target_client_id, user_id, created, modified) values
											('Tavoitettu', '$time', '$time', 1,1,'$time','$time') ");
	// Nyt meill pitisi olla yksi
	$this->assertEqual(1, $this->controller->CampaignsUser->getCallsDoneToday(1,1));
	$id_talteen = mysql_insert_id();
	$this->controller->Event->del($id_talteen);
	//Kannassa ei ole yhtn tlle pivlle
    
	$this->assertEqual(0, $this->controller->CampaignsUser->getCallsDoneToday(1,1));
	// Hphp palauttaa null
	$this->assertEqual(0, $this->controller->CampaignsUser->getCallsDoneToday(-1,-1));
  }
  
  function testgetUserCampaigns(){
    
    //Kolmea kampanjaa odottelemme
    $this->assertEqual(3,count($this->controller->CampaignsUser->getUserCampaigns(1)));
    $result = $this->controller->CampaignsUser->getUserCampaigns(1);
    $i = 0;
    foreach ($result as $resultrow) {
        if (!empty($resultrow['Event']['contact_at'])){
            ++$i;
        }        
    }
    //Vain yhdess saa olla contact_at asetettuna
    $this->assertEqual(1, $i, "Contact_atteja");
    
    //Ensimmisess kampanjassa on contact_at 2007-07-16 10:00:00
	$this->assertEqual(1, $result[1]['Campaign']['id']);
    $this->assertEqual("2007-07-16 10:00:00", $result[1]['Event']['contact_at']);
    //Pitisi tulla null, jos haetaan olemattomalla kyttjll
	$this->assertNull($result = $this->controller->CampaignsUser->getUserCampaigns(-1));	
  }
  
  function testgetCampaignList(){
    // 34 asiakasta ykkskampanjassa, kaikki kesken
    $this->assertEqual(34, count($this->controller->CampaignsUser->getCampaignList(-1, 1, -1)));
    $this->assertEqual(34, count($this->controller->CampaignsUser->getCampaignList(-1, 1, 0)));
    // Nist 19 on ykksmyyjll, kaikki kesken
    $this->assertEqual(19, count($this->controller->CampaignsUser->getCampaignList(1, 1, -1)));
    $this->assertEqual(19, count($this->controller->CampaignsUser->getCampaignList(1, 1, 0)));
    //Pivitetnps joku valmiiksi
	$asiakas = $this->controller->TargetClient->findById(1);
	unset($asiakas['TargetClient']['y_id']);
	$talteen = $asiakas;
		
	$asiakas['TargetClient']['target_client_state_id'] = 'Tavoite saavutettu';	
	$this->assertTrue($this->controller->TargetClient->save($asiakas));
	
	//Tarkistetaanpas taas
	$this->assertEqual(1, count($this->controller->CampaignsUser->getCampaignList(1, 1, 1)));
	
	$this->assertEqual(1, count($this->controller->CampaignsUser->getCampaignList(-1, 1, 1)));
    //Vanhat takas
	$this->controller->TargetClient->save($talteen);
	//Testataapas omituisia
	$this->assertNull($this->controller->CampaignsUser->getCampaignList(-1, -1, 1));
	$this->assertNull($this->controller->CampaignsUser->getCampaignList(-2, 1, 1));
	$this->assertNull($this->controller->CampaignsUser->getCampaignList(-2, -2, -4));
  }
  
  function testgetUsersTargets(){
    // 34 on tll
    $this->assertEqual(34, count($this->controller->CampaignsUser->getUsersTargets(1)));
    
    
    //AppController::printVariable($this->controller->CampaignsUser->getUsersTargets(1));
    $this->assertNull($this->controller->CampaignsUser->getUsersTargets(22));
    // Tarkistetaan, ett id 53 on null user_id
	$array = $this->controller->CampaignsUser->getUsersTargets(1);
    $this->assertEqual(53, $array[33]['TargetClient']['id']);
    $this->assertNotNull($array[0]['User']['id']);
    $this->assertNull($array[33]['User']['id']);
  }
  
  
}


?>