<?php
/**
 * Event-luokan testit
 *
 */
class EventTest extends UnitTestCase {
  var $controller;
  function __construct(&$controller){
    parent::__construct();
    $this->controller = &$controller;
    $this->UnitTestCase(); 
  }

  function testgetTargetClientsEvents(){
    // Asiakkaalla 7 on seitsemn tapahtumaa
    $this->assertEqual(7, count($this->controller->Event->getTargetClientsEvents(7)));
    //Asiakkaalla -1 ei ole tapahtumia
	$this->assertEqual(0, count($this->controller->Event->getTargetClientsEvents(-1)));
	// Tuosta eteenpin on 5 
	$this->assertEqual(5, count($this->controller->Event->getTargetClientsEvents(7, '2007-07-11')));
	// 11 piv on 4
	$this->assertEqual(4, count($this->controller->Event->getTargetClientsEvents(7, '2007-07-11', '2007-07-11' )));
	
  }
  
  function testgetTargetClientCountByEventType(){
    //2 kohdeasiakasta kyttjll 1 kampanjassa 1 ilman rajauksia ehdolla 'Tavoitettu'
    $this->assertEqual(2, $this->controller->Event->getTargetClientCountByEventType(1,1,array('Tavoitettu'),null,null,true));
    //lis event_typej
    $this->assertEqual(3, $this->controller->Event->getTargetClientCountByEventType(1,1,array('Tavoitettu','Varattu'),null,null,true));
    $this->assertEqual(7, $this->controller->Event->getTargetClientCountByEventType(1,1,array('Lhetetty','Varattu'),null,null,true));
    //rajauksella
    $this->assertEqual(6, $this->controller->Event->getTargetClientCountByEventType(1,1,array('Luotu'),'2007-07-01','2007-07-01',true));
    $this->assertEqual(1, $this->controller->Event->getTargetClientCountByEventType(1,1,array('Luotu'),'2007-07-10',null,true));
    $this->assertEqual(2, $this->controller->Event->getTargetClientCountByEventType(1,1,array('Luotu','Ei paikalla'),'2007-07-10',null,true));
    $this->assertEqual(1, $this->controller->Event->getTargetClientCountByEventType(1,1,array('Tavoitettu'),'2007-07-10','2007-07-14',true));
    $this->assertEqual(2, $this->controller->Event->getTargetClientCountByEventType(1,1,array('Tavoitettu'),'2007-07-10','2007-07-15',true));

    //include=false
    //$this->assertEqual(5, $this->controller->Event->getTargetClientCountByEventType(1,1,array('Varattu'),null,null,false));
    
    // Oletettavasti tarpeeton metodi
	//eip ole kesken
      
  }
  
  function testgetClientEventTypesReport(){
    //AppController::printVariable($this->controller->Event->getClientEventTypesReport(-1,1, array('Soitto')));
    //7 linkki odottelemme
    $this->assertEqual(7,count($this->controller->Event->getClientEventTypesReport(-1,1, array('Soitto'))));
    $result = $this->controller->Event->getClientEventTypesReport(-1,1, array('Soitto'));
    
    
    //Neljs rivi sislt kamaa
    $this->assertEqual("Tavoitettu", $result[6]['Event']['event_type_id']);
    $this->assertEqual(3, $result[6]['Event']['count']);
    $this->assertEqual((3/34)*100, $result[6]['Event']['percentage_all']);    
    $this->assertEqual((3/4)*100, $result[6]['Event']['percentage_limit']);

    //Entp jos rajataan?
	$this->assertEqual(7,count($this->controller->Event->getClientEventTypesReport(-1,1, array('Soitto'), "2007-07-11")));
    $result = $this->controller->Event->getClientEventTypesReport(-1,1, array('Soitto'), "2007-07-13");
    // Tuolla on nyt 100
    $this->assertEqual(100, $result[6]['Event']['percentage_limit']);
    // Tll vain yksi
    $result = $this->controller->Event->getClientEventTypesReport(-1,1, array('Soitto'), "2007-07-11", "2007-07-13");
    
    $this->assertEqual("Varattu", $result[4]['Event']['event_type_id']);
    $this->assertEqual(1, $result[4]['Event']['count']);
    
	
  }
  
  function testChooseNextCall() {
    $this->controller->Event->execute("BEGIN WORK");
    //Luodaan uusi kyttjasiakas
	$save_array_userclient['UserClient']['name'] = "TargetClientTestUserClient";
    $this->controller->UserClient->save($save_array_userclient);
    $UserClientId = $this->controller->UserClient->getLastInsertId();
    $this->removerarray[] = array('model' => 'user_clients', 'id' => $UserClientId);
    // Luodaa uusi tyntekij
	$save_array_user['User']['username'] = "TestUser1";
	$save_array_user['User']['user_client_id'] = $UserClientId;
	$this->controller->User->save($save_array_user);
	$UserId = $this->controller->User->getLastInsertId();
	$this->user_id = $UserId;
	// Luodaan uusi kampanja
	$save_array_campaign['Campaign']['name'] = "TargetClientTestCampaign";
	$save_array_campaign['Campaign']['start_time'] = "2007-06-01";
	$save_array_campaign['Campaign']['user_client_id'] = $UserClientId;
	$this->controller->Campaign->save($save_array_campaign);
	$campaign_id = $this->controller->Campaign->getLastInsertId(); 
	$this->campaign_id = $campaign_id;
	// liitetn asiakas kampanjaan
	$save_array_campaigns_user['CampaignsUser']['user_id'] = $UserId;
	$save_array_campaigns_user['CampaignsUser']['campaign_id'] = $this->campaign_id;
	$save_array_campaigns_user['CampaignsUser']['accomplished_amount'] = 10;
	$this->controller->CampaignsUser->save($save_array_campaigns_user);
	$campaigns_user_id = $this->controller->CampaignsUser->getLastInsertId();
	for ($i = 0; $i<8; ++$i){
	  unset($save_array_target_client);
	  $save_array_target_client['TargetClient']['id'] = null;
	  $save_array_target_client['TargetClient']['name'] = "TargetClientTestCampaign" . $i;
	  $save_array_target_client['TargetClient']['campaigns_user_id'] = $campaigns_user_id;
	  $save_array_target_client['TargetClient']['campaign_id'] = $this->campaign_id;
	  if ($i == 0){
	    $save_array_target_client['TargetClient']['target_client_state_id'] = "Ei aloitettu";  
	  } else if ($i<3){
	    $save_array_target_client['TargetClient']['target_client_state_id'] = "Tavoite saavutettu";
	  } else {
	    $save_array_target_client['TargetClient']['target_client_state_id'] = "Tavoitetta ei saavutettu";	    
	  }	  	  
	  $this->controller->TargetClient->save($save_array_target_client);
	  $target_client_list[] = $this->controller->TargetClient->getLastInsertId();
	}    
    
    
	$time = date("Y-m-d H:m:s", time());
	$array = array();

	$this->controller->Event->execute("INSERT INTO events (event_type_id, start_time, end_time, contact_at, target_client_id, user_id, created, modified) values
											('Ei paikalla', '$time', '$time', addtime(now(), ('00:10:00')), $target_client_list[0], $UserId,'$time','$time')",false);
	$array[]=mysql_insert_id();
	
	$this->controller->Event->execute("INSERT INTO events (event_type_id, start_time, end_time, contact_at, target_client_id, user_id, created, modified) values
											('Ei paikalla', '$time', '$time', addtime(now(), ('00:10:00')), $target_client_list[1], $UserId,'$time','$time')",false);
	$array[]=mysql_insert_id();
	
	$this->controller->Event->execute("INSERT INTO events (event_type_id, start_time, end_time, contact_at, target_client_id, user_id, created, modified) values
											('Ei paikalla', '$time', '$time', addtime(now(), ('00:10:00')), $target_client_list[2], $UserId,'$time','$time')",false);
    $array[]=mysql_insert_id();
    
	$this->controller->Event->execute("INSERT INTO events (event_type_id, start_time, end_time, contact_at, target_client_id, user_id, created, modified) values
											('Ei paikalla', '$time', '$time', addtime(now(), ('00:10:00')), $target_client_list[3], $UserId,'$time','$time')",false);
	$array[]=mysql_insert_id();
	
	$this->controller->Event->execute("INSERT INTO events (event_type_id, start_time, end_time, contact_at, target_client_id, user_id, created, modified) values
											('Varattu', '$time', '$time', addtime(now(), ('00:10:00')), $target_client_list[4], $UserId,'$time','$time')",false);
	$array[]=mysql_insert_id();
	
	$this->controller->Event->execute("INSERT INTO events (event_type_id, start_time, end_time, contact_at, target_client_id, user_id, created, modified) values
											('Ei paikalla', '$time', '$time', addtime(now(), ('00:10:00')), $target_client_list[5], $UserId,'$time','$time')",false);
    $array[]=mysql_insert_id();
	
	$this->controller->Event->execute("INSERT INTO events (event_type_id, start_time, end_time, contact_at, target_client_id, user_id, created, modified) values
											('Ei paikalla', '$time', '$time', addtime(now(), ('00:10:00')), $target_client_list[6], $UserId,'$time','$time')",false);
    $array[]=mysql_insert_id();
    
    //valitaan prioriteetin mukaan
	
    $tar_id = $target_client_list[4];
	$this->assertEqual($tar_id,$this->controller->Event->chooseNextCall($UserId,$campaign_id));
    
	foreach($array as $arr){
      $this->controller->Event->execute("DELETE FROM events where id = $arr",false);
	}
    
    //tuleeko virhe, jos kyttj ei kuulu kampanjaan
    $this->assertFalse($this->controller->Event->chooseNextCall(7,$UserId));
    $this->assertFalse($this->controller->Event->chooseNextCall(6,$UserId));
    //odotellaan target_client_id:t 23
    // $this->assertEqual(23,$this->controller->Event->chooseNextCall(1,1));
    //null, jos myyjll ei ole viel kohdeasiakkaita
    $this->assertNull($this->controller->Event->chooseNextCall(2,1));
    $this->controller->Event->execute('ROLLBACK');
    
  }
  
  function testgetDifferentEmailCounts(){
    // Ensimmisess kampanjassa on testidatassa 6 klikkausta kyttjill
	$this->assertEqual(6, $this->controller->Event->getDifferentEmailCounts(1,1));
  }
  
  function testgetEmailLinksReport(){
    //Nelj linkki odottelemme
    $this->assertEqual(4,count($this->controller->Event->getEmailLinksReport(-1,1)));
    $result = $this->controller->Event->getEmailLinksReport(-1,1);
  
    //Ensimminen linkki
    $this->assertEqual("http://www.auto.fi", $result[0]['MessageLink']['target_url']);
    $this->assertEqual("www.auto.fi", $result[0]['MessageLink']['target_url_text']);
    $this->assertEqual(3, $result[0]['EventLink']['event_count']);   
    $this->assertEqual(8.823529411764706, $result[0]['EventLink']['percentage_all']);   
    $this->assertEqual(8.571428571428571, $result[0]['EventLink']['percentage_called']);  

    //Toinen linkki
    $this->assertEqual("http://www.ferrari.fi", $result[1]['MessageLink']['target_url']);
    $this->assertEqual("www.ferrari.fi", $result[1]['MessageLink']['target_url_text']);
    $this->assertEqual(2, $result[1]['EventLink']['event_count']);    
    $this->assertEqual(5.882352941176470, $result[1]['EventLink']['percentage_all']);   
    $this->assertEqual(5.714285714285714, $result[1]['EventLink']['percentage_called']);  

    //Kolmas linkki
    $this->assertEqual("http://www.fiat.fi", $result[2]['MessageLink']['target_url']);
    $this->assertEqual("www.fiat.fi", $result[2]['MessageLink']['target_url_text']);
    $this->assertEqual(4, $result[2]['EventLink']['event_count']); 
    $this->assertEqual(11.76470588235294, $result[2]['EventLink']['percentage_all']);   
    $this->assertEqual(11.428571428571429, $result[2]['EventLink']['percentage_called']);    
    
    //Neljs linkki
    $this->assertEqual("http://www.nissan.fi", $result[3]['MessageLink']['target_url']);
    $this->assertEqual("www.nissan.fi", $result[3]['MessageLink']['target_url_text']);
    $this->assertEqual(2, $result[3]['EventLink']['event_count']);
    $this->assertEqual(5.882352941176470, $result[3]['EventLink']['percentage_all']);   
    $this->assertEqual(5.714285714285714, $result[3]['EventLink']['percentage_called']);     
    
    //Ei odoteta mitn
    $this->assertEqual(0,count($this->controller->Event->getEmailLinksReport(2,1)));

    //Nelj linkki odottelemme pivmr rajauksilla
    $this->assertEqual(4,count($this->controller->Event->getEmailLinksReport(-1,1,'2007-07-01','2007-07-14')));
    $result = $this->controller->Event->getEmailLinksReport(-1,1,'2007-07-01','2007-08-01');

    //Nelj linkki odottelemme pivmr rajauksilla
    $this->assertEqual(4,count($this->controller->Event->getEmailLinksReport(-1,1,'2007-07-01')));
    $result = $this->controller->Event->getEmailLinksReport(-1,1,'2007-07-01');
  }
}