<?php
/**
 * TargetClient-luokan testit
 *
 */
class TargetClientTest extends UnitTestCase {
  
  var $controller;
  var $removerarray;
  var $user_id;
  var $campaign_id;
  
  function __construct(&$controller){
    parent::__construct();
    $this->controller = &$controller;
    $this->UnitTestCase(); 
  }
  
  function setUp(){
    //Luodaan uusi kyttjasiakas
	$save_array_userclient['UserClient']['name'] = "TargetClientTestUserClient";
    $this->controller->UserClient->save($save_array_userclient);
    $UserClientId = $this->controller->UserClient->getLastInsertId();
    $this->removerarray[] = array('model' => 'user_clients', 'id' => $UserClientId);
    // Luodaa uusi tyntekij
	$save_array_user['User']['username'] = "TestUser1";
	$save_array_user['User']['user_client_id'] = $UserClientId;
	$this->controller->User->save($save_array_user);
	$UserId = $this->controller->User->getLastInsertId();
	$this->user_id = $UserId;
	// Luodaan uusi kampanja
	$save_array_campaign['Campaign']['name'] = "TargetClientTestCampaign";
	$save_array_campaign['Campaign']['start_time'] = "2007-06-01";
	$save_array_campaign['Campaign']['user_client_id'] = $UserClientId;
	$this->controller->Campaign->save($save_array_campaign);
	$campaign_id = $this->controller->Campaign->getLastInsertId(); 
	$this->campaign_id = $campaign_id;
	// liitetn asiakas kampanjaan
	$save_array_campaigns_user['CampaignsUser']['user_id'] = $UserId;
	$save_array_campaigns_user['CampaignsUser']['campaign_id'] = $this->campaign_id;
	$save_array_campaigns_user['CampaignsUser']['accomplished_amount'] = 10;
	$this->controller->CampaignsUser->save($save_array_campaigns_user);
	$campaigns_user_id = $this->controller->CampaignsUser->getLastInsertId();
	// Luodaan -1 kampanja
	$save_array_campaign['Campaign']['id'] = null;
	$save_array_campaign['Campaign']['name'] = "TargetClientTestCampaign-1";
	$save_array_campaign['Campaign']['start_time'] = "2007-06-01";
	$save_array_campaign['Campaign']['user_client_id'] = $UserClientId;
	$this->controller->Campaign->save($save_array_campaign);
	$campaign_id = $this->controller->Campaign->getLastInsertId(); 
	$this->campaign_id2 = $campaign_id;
	// liitetn asiakas kampanjaan
	$save_array_campaigns_user['CampaignsUser']['id'] = null;
	$save_array_campaigns_user['CampaignsUser']['user_id'] = $UserId;
	$save_array_campaigns_user['CampaignsUser']['campaign_id'] = $this->campaign_id2;
	$save_array_campaigns_user['CampaignsUser']['accomplished_amount'] = 10;
	$this->controller->CampaignsUser->save($save_array_campaigns_user);	
	//Luodaan toinen kyttj 
	$save_array_user['User']['id'] = null;
	$save_array_user['User']['username'] = "TestUser2";
	$save_array_user['User']['user_client_id'] = $UserClientId;
	$this->controller->User->save($save_array_user);
	$UserId2 = $this->controller->User->getLastInsertId(); 
	// liitetn asiakas kampanjaan
	$save_array_campaigns_user['CampaignsUser']['id'] = null;
	$save_array_campaigns_user['CampaignsUser']['user_id'] = $UserId2;
	$save_array_campaigns_user['CampaignsUser']['campaign_id'] = $this->campaign_id;
	$save_array_campaigns_user['CampaignsUser']['accomplished_amount'] = 5;
	$this->controller->CampaignsUser->save($save_array_campaigns_user);
	$campaigns_user_id2 = $this->controller->CampaignsUser->getLastInsertId();
	// luodaan target clientteja
	for ($i = 0; $i<5; ++$i){
	  unset($save_array_target_client);
	  $save_array_target_client['TargetClient']['id'] = null;
	  $save_array_target_client['TargetClient']['name'] = "TargetClientTestCampaign" . $i;
	  $save_array_target_client['TargetClient']['campaigns_user_id'] = $campaigns_user_id;
	  $save_array_target_client['TargetClient']['campaign_id'] = $this->campaign_id;
	  if ($i == 0){
	    $save_array_target_client['TargetClient']['target_client_state_id'] = "Ei aloitettu";  
	  } else if ($i<3){
	    $save_array_target_client['TargetClient']['target_client_state_id'] = "Tavoite saavutettu";
	  } else {
	    $save_array_target_client['TargetClient']['target_client_state_id'] = "Tavoitetta ei saavutettu";	    
	  }	  
	  $this->controller->TargetClient->save($save_array_target_client);
	}
  // luodaan target clientteja toiselle
	
    for ($i = 0; $i<5; ++$i){
	  unset($save_array_target_client);
	  $save_array_target_client['TargetClient']['id'] = null;
	  $save_array_target_client['TargetClient']['name'] = "TargetClientTestCampaign2" . $i;
	  $save_array_target_client['TargetClient']['campaigns_user_id'] = $campaigns_user_id2;
	  $save_array_target_client['TargetClient']['campaign_id'] = $this->campaign_id;
	  if ($i == -1){
	    $save_array_target_client['TargetClient']['target_client_state_id'] = "Ei aloitettu";  
	  } else if ($i<2){
	    $save_array_target_client['TargetClient']['target_client_state_id'] = "Tavoite saavutettu";
	  } else {
	    $save_array_target_client['TargetClient']['target_client_state_id'] = "Tavoitetta ei saavutettu";	    
	  }	  
	  $this->controller->TargetClient->save($save_array_target_client);
	  
	  
	}
	
	

  }
  
  function testgetTargetClientsNeeded(){
        $this->assertEqual(15, $this->controller->TargetClient->getTargetClientsNeeded($this->user_id, $this->campaign_id));
        $this->assertEqual(24, $this->controller->TargetClient->getTargetClientsNeeded(-1, $this->campaign_id));
        // retn mr
        $this->assertEqual(-1, $this->controller->TargetClient->getTargetClientsNeeded(-1, $this->campaign_id2));
        $this->assertEqual(false, $this->controller->TargetClient->getTargetClientsNeeded(-1, -1));
        $this->assertEqual(false, $this->controller->TargetClient->getTargetClientsNeeded("kukka", "kaali"));
  }
  
  function tearDown(){
    foreach ($this->removerarray as $removable) {
    	
        $this->controller->UserClient->query("delete from $removable[model] where id = $removable[id]");
     
    }
    
  }

}
