<?php
class Time_fiHelper extends TimeHelper {

  const DATE_FORMAT = 'j.n.Y';
  const TIME_FORMAT = 'H:i';


  /**
   * Palauttaa parametrina annetun pivmrn muodossa p.k.vvvv.
   * @param date_string UNIX timestamp tai kelvollinen strtotime()-merkkijono.
   */
  function toDate($date_string) {    
    
    if (empty($date_string)) {
      return '';
    } else {
      return (date(Time_fiHelper::DATE_FORMAT, $this->fromString($date_string)));
    }
  }


  /**
   * Palauttaa parametrina annetun ajan muodossa tt:mm.
   * @param date_string UNIX timestamp tai kelvollinen strtotime()-merkkijono.
   */
  function toTime($date_string) {
    if (empty($date_string)) {
      return '';
    } else {
      return (date(Time_fiHelper::TIME_FORMAT, $this->fromString($date_string)));
    }
  }


  /**
   * Palauttaa parametrina annetun pivmrn ja ajan muodossa p.k.vvvv tt:mm.
   * @param date_string UNIX timestamp tai kelvollinen strtotime()-merkkijono.
   */
  function toDateTime($date_string) {
    if (empty($date_string)) {
      return '';
    } else {
      return (date(Time_fiHelper::DATE_FORMAT . ' ' . Time_fiHelper::TIME_FORMAT, $this->fromString($date_string)));
    }
  }


  /**
   * Suomennettu versio TimeHelper:n vastaavasta. Nytt lisksi "huomisen"
   *
   * Returns a formatted descriptive date string for given datetime string.
   *
   * If the given date is today, the returned string could be "tnn klo 16:54".
   * If the given date is tomorrow, the returned string could be "huomenna klo 16:54".
   * If the given date was yesterday, the returned string could be "huomenna klo 16:54".
   * If $date_string's year is the current year, the returned string does not
   * include mention of the year.
   *
   * @param string $date_string Datetime string or Unix timestamp
   * @param  boolean $return Whether this method should return a value or output it. This overrides AUTO_OUTPUT.
   * @return string Described, relative date string
   * @access public
   */
  function niceShort($date_string = null, $return = false) {
    $date = $date_string ? $this->fromString($date_string) : time();
    $y = $this->isThisYear($date) ? '' : 'Y';

    if ($this->isToday($date)) {
      $ret = 'tnn klo ' . date(Time_fiHelper::TIME_FORMAT, $date);
    } elseif($this->isTomorrow($date)) {
      $ret = 'huomenna klo ' . date(Time_fiHelper::TIME_FORMAT, $date);
    } elseif($this->wasYesterday($date)) {
      $ret = 'eilen klo ' . date(Time_fiHelper::TIME_FORMAT, $date);
    } else {
      $ret = date('j.n.' . $y . ' \k\l\o ' . Time_fiHelper::TIME_FORMAT, $date);
    }

    return $this->output($ret, $return);
  }

  function validTime($date_string){
    $leapyear = false;
    $time = explode($date_string, " ");
    // Pit olla kaksi osaa
    if (!count($time) == 2){
      return false;
    }
    // Meill on siis kaksi osaa
	// tsekataanpas eka
	$date = explode($time[0], ".");
	if (!count($date) == 3 ){
	  return false;
	} else {
	  // Tarkistetaan vuosi
	  if (!is_numeric($date[2]) || $date[2] <0){
	    return false; 
	  }
	  //Mritetn karkausvuosi
	  
	}

  }
}
?>
